SystemOrganization addCategory: #'SIXX-Squeak'!
SystemOrganization addCategory: #'SIXX-Core'!
SystemOrganization addCategory: #'SIXX-ParserAdapter'!
SystemOrganization addCategory: #'SIXX-Examples'!
SystemOrganization addCategory: #'SIXX-Test'!

!ByteArray class methodsFor: '*sixx-instance creation' stamp: 'mu 6/26/2004 18:36'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| rawStr col |
	rawStr := ReadStream
				on: (SixxXmlUtil characterDataFrom: sixxElement).
	col := rawStr peek = $#
				ifTrue: [Array readFrom: rawStr]
				ifFalse: [self readShortHexFrom: rawStr].
	^ self withAll: col! !

!ByteArray class methodsFor: '*sixx-instance creation' stamp: 'minami 7/14/2004 01:00'!
readShortHexFrom: aStream
	| sz inst |
	sz := aStream size // 2.
	inst := self new: sz.
	1 to: sz do: [:idx | 
		inst at: idx put: (Integer readShortHexFrom: (aStream next: 2) readStream)
	].
	^ inst! !

!ByteArray methodsFor: '*sixx-converting' stamp: 'minami 7/14/2004 00:42'!
shortHexString
	| sz stream |
	sz := self size.
	stream := WriteStream on: (String new: sz * 2).
	1 to: sz do: [:idx | 
		| elem |
		elem := (self at: idx).
		elem < 16 ifTrue: [stream nextPut: $0].
		stream nextPutAll:  elem shortHexString].
	^ stream contents  ! !

!ByteArray methodsFor: '*sixx-printing' stamp: 'minami 7/14/2004 00:43'!
sixxContentOn: aStream indent: level context: dictionary 
	1 to: self size do: [:idx | 
		| elem |
		elem := (self at: idx).
		elem < 16 ifTrue: [aStream nextPut: $0].
		aStream nextPutAll: elem shortHexString].
	! !

!Time class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:23'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Time methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 22:29'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!Time methodsFor: '*sixx-private' stamp: 'MU 9/16/2002 22:28'!
sixxContentString
	"Squeak Specific"
	^self printString! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/26/2004 18:05'!
initializeFromSixxElement: sixxElement context: aDictionary 
	self class isBits
		ifTrue: [^ self initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary].
	self class isVariable
		ifTrue: [^ self initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary].
	self initializeInstVarsFromSixxElement: sixxElement context: aDictionary! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 03:54'!
initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary 
	| idx nonameElems |
	idx := 1.
	nonameElems := (SixxXmlUtil elementsFrom: sixxElement)
				select: [:each | (self class nameFromSixxElement: each) isNil].
	nonameElems isEmpty
		ifFalse: [nonameElems
				do: [:elem | | childInst | (SixxXmlUtil isTextFrom: elem)
						ifFalse: [childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxAt: idx put: childInst.
							idx := idx + 1]]]! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/26/2004 18:04'!
initializeInstVarsFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/26/2004 18:05'!
initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary 
	self initializeInstVarsFromSixxElement: sixxElement context: aDictionary.
	self initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary ! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 01:12'!
sixxAt: index put: aValue 
	"override if you like"
	self at: index put: aValue ! !

!Object methodsFor: '*sixx-private' stamp: 'mu 6/26/2004 16:45'!
sixxChildrenContentsOn: aStream indent: level context: dictionary 
	self class isBits
		ifTrue: [aStream nextPutAll: '#( '.
			1 to: self size do: [:idx | 
				aStream nextPutAll: (self at: idx) asString; space
			].
			aStream nextPutAll: ')'.
			^ self].
		
	self class isVariable
		ifTrue: [^ self
				sixxMixedFieldsOn: aStream
				indent: level
				context: dictionary].
			
	self
		sixxInstVarsOn: aStream
		indent: level
		context: dictionary! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:34'!
sixxContentOn: aStream indent: level context: dictionary
	"override if you like"
	self sixxChildrenContentsOn: aStream indent: level + 1 context: dictionary.
	aStream tab: level.
! !

!Object methodsFor: '*sixx-private' stamp: 'MU 3/6/2003 15:45'!
sixxEnv
	^SixxPortableUtil environmentQualifierOf: self class! !

!Object methodsFor: '*sixx-private' stamp: 'MU 3/6/2003 15:45'!
sixxEnvAttribString
	^'sixx.env="' , self sixxEnv , '" '! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxIdAttribString: idString
	^'sixx.id="', idString asString, '" '! !

!Object methodsFor: '*sixx-private' stamp: 'mu 7/20/2006 12:42'!
sixxIgnorableInstVarNames
	"override if you wish"
	"If you would like to omit some inst vars in serialization, list their names here."

	^#()! !

!Object methodsFor: '*sixx-private' stamp: 'mu 7/20/2006 12:40'!
sixxIndexFieldsOn: aStream indent: level context: dictionary 
	"override if you like"
	| size |
	size := self basicSize.
	size = 0
		ifTrue: [^ self].
	1
		to: size
		do: [:i | 
			| element | 
			element := self basicAt: i.
			element sixxValue
				sixxOn: aStream
				indent: level
				context: dictionary]! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/24/2004 21:40'!
sixxInitialize
	"override if you like"
	"The method is called after the loading of the receiver - just like #initializaAfterLoad in Envy"
	"It is useful to initializa attributes that cannot be stored in SIXX (Block, Context, etc)"! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 7/20/2006 22:18'!
sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	| index |
	index _ self class allInstVarNames indexOf: instVarName asString.
	index = 0 ifTrue: [^self].
	self
		instVarAt: index
		put: aValue! !

!Object methodsFor: '*sixx-private' stamp: 'mu 7/20/2006 12:42'!
sixxInstVarNamed: varName value: varValue on: aStream indent: level context: dictionary 
	"override if you wish"
	(self sixxIgnorableInstVarNames includes: varName) ifTrue: [^self].
	varValue sixxValue
		sixxOn: aStream
		name: varName
		indent: level
		context: dictionary! !

!Object methodsFor: '*sixx-private' stamp: 'mu 7/20/2006 12:27'!
sixxInstVarsOn: aStream indent: level context: dictionary 
	| instVars ind |
	aStream cr.
	instVars := self class allInstVarNames.
	ind := 0.
	instVars
		do: [:nm | 
			ind := ind + 1.
			self
				sixxInstVarNamed: nm
				value: (self instVarAt: ind)
				on: aStream
				indent: level
				context: dictionary]! !

!Object methodsFor: '*sixx-private' stamp: 'mu 6/26/2004 16:45'!
sixxMixedFieldsOn: aStream indent: level context: dictionary
	self sixxInstVarsOn: aStream indent: level context: dictionary.
	self sixxIndexFieldsOn: aStream indent: level context: dictionary.! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxNameAttribString: idString
	^'sixx.name="', idString asString, '" '! !

!Object methodsFor: '*sixx-printing' stamp: 'kuri-t 5/17/2002 14:27'!
sixxOn: aStream 
	self sixxOn: aStream indent: 0 context: IdentityDictionary new! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:35'!
sixxOn: aStream indent: level context: dictionary
	^self sixxOn: aStream name: nil indent: level context: dictionary! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:35'!
sixxOn: aStream name: nameString indent: level context: dictionary 
	aStream tab: level.
	(dictionary includesKey: self)
		ifTrue: [aStream
				nextPutAll: (self
						sixxRefTagStartString: (dictionary at: self) name: nameString)]
		ifFalse: [| idStr | 
			idStr := dictionary size asString.			
			dictionary at: self put: idStr.
			aStream
				nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxRefTagStartString: idString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	idString isNil
		ifFalse: [wStr
				nextPutAll: idString].
	wStr nextPutAll: '" >'.
	^ wStr contents! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxRefTagStartString: idString name: nameString 
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	wStr nextPutAll: idString.
	wStr nextPutAll: '" '.
	nameString notNil
		ifTrue: [wStr nextPutAll: 'sixx.name="'.
			wStr nextPutAll: nameString.
			wStr nextPutAll: '" '].
	wStr nextPutAll: '>'.
	^ wStr contents! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:34'!
sixxString
	| wStr |
	wStr := (String new: 128) writeStream.
	self sixxOn: wStr.
	^wStr contents! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxTagEndString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '</sixx.object>'.
	^wStr contents
	! !

!Object methodsFor: '*sixx-private' stamp: 'MU 3/6/2003 15:47'!
sixxTagStartString: idString name: nameString 
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object '.
	idString isNil
		ifFalse: [wStr
				nextPutAll: (self sixxIdAttribString: idString)].
	nameString isNil
		ifFalse: [wStr
				nextPutAll: (self sixxNameAttribString: nameString)].
	wStr nextPutAll: self sixxTypeAttribString.
	SixxSetting useEnvironment ifTrue: [wStr nextPutAll: self sixxEnvAttribString.].
	wStr nextPutAll: '>'.
	^ wStr contents! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxType
	^self class name! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxTypeAttribString
	^'sixx.type="', self sixxType, '" '! !

!Object methodsFor: '*sixx-private' stamp: 'mu 7/20/2006 12:40'!
sixxValue
	"override if you wish"
	"It can be useful when you would like to store the receiver in a memento (minimal representation) form."

	^self! !

Object subclass: #SixxConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

SixxConstants class
	instanceVariableNames: 'xmlVersion xmlEncoding sixxVersion sixxStartTag xmlDeclaration'!

!SixxConstants class methodsFor: 'class initialization' stamp: 'MU 5/23/2002 17:29'!
initialize
	xmlVersion := nil.
	xmlEncoding := nil.
	sixxVersion := nil.
	sixxStartTag := nil.
	xmlDeclaration := nil! !

!SixxConstants class methodsFor: 'constants' stamp: 'MU 5/23/2002 17:30'!
sixxEndTag
	^ '</sixx>' copy! !

!SixxConstants class methodsFor: 'constants' stamp: 'MU 5/23/2002 17:27'!
sixxStartTag
	sixxStartTag isNil ifTrue: [sixxStartTag := '<sixx sixx.version="' , self sixxVersion , '">'].
	^sixxStartTag
		
! !

!SixxConstants class methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 17:59'!
sixxVersion
	sixxVersion isNil ifTrue: [sixxVersion := '1.0'].
	^sixxVersion! !

!SixxConstants class methodsFor: 'accessing' stamp: 'MU 5/23/2002 17:28'!
sixxVersion: versionString 
	sixxStartTag := nil.
	sixxVersion := versionString! !

!SixxConstants class methodsFor: 'constants' stamp: 'MU 5/23/2002 17:24'!
xmlDeclaration
	xmlDeclaration isNil ifTrue: [xmlDeclaration := '<?xml version="', self xmlVersion, '" encoding="', self xmlEncoding, '"?>'].
	^xmlDeclaration
	! !

!SixxConstants class methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 17:58'!
xmlEncoding
	xmlEncoding isNil ifTrue: [xmlEncoding := 'utf-8'].
	^ xmlEncoding! !

!SixxConstants class methodsFor: 'accessing' stamp: 'MU 5/23/2002 17:24'!
xmlEncoding: encodingString 
	xmlDeclaration := nil.
	xmlEncoding := encodingString! !

!SixxConstants class methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 17:57'!
xmlVersion
	xmlVersion isNil ifTrue: [xmlVersion := '1.0'].
	^ xmlVersion! !

!SixxConstants class methodsFor: 'accessing' stamp: 'MU 5/23/2002 17:24'!
xmlVersion: versionString 
	xmlDeclaration := nil.
	xmlVersion := versionString! !

Object subclass: #SixxCustomStoreLoadExample
	instanceVariableNames: 'id cachedData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Examples'!

SixxCustomStoreLoadExample class
	instanceVariableNames: 'instances cachedData'!

!SixxCustomStoreLoadExample commentStamp: '<historical>' prior: 0!
I am an example of SIXX custom serialization.
SIXX normally writes/reads all attribute values (instance variables).
But sometimes this behavior is not appropriate. For example, I would like to omit writing/reading a "cachedData" value, because it is only a cache.

By overriding hook methods below, you can customize what attributes are written or read.

(instance methods)
#sixxIgnorableInstVarNames (for reading/writing)

#sixxContentOn: aStream indent: level context: dictionary (for writing)
#sixxInstVarNamed: instVarName put: aValue (for reading)

(class methods)
#sixxContentOn: aStream indent: level context: dictionary (for writing)
#sixxInstVarNamed: instVarName put: aValue (for reading)

#createInstanceOf: aClass withSixxElement: sixxElement (for writing)
(It is useful for variable objects. See implementors.)

---
MU 6/14/2002 11:12



!

!SixxCustomStoreLoadExample class methodsFor: 'examples' stamp: 'MU 6/14/2002 11:15'!
example1
	"SixxCustomStoreLoadExample example1"
	"Writing custom serialization object"
	| inst xml |
	inst := SixxCustomStoreLoadExample random.
	xml := inst sixxString.
	Transcript cr; show: self name, ' instance sixx is...'; cr; show: xml.
	^xml

! !

!SixxCustomStoreLoadExample class methodsFor: 'examples' stamp: 'MU 6/14/2002 11:15'!
example2
	"SixxCustomStoreLoadExample example2"
	"Reading custom serialization object"
	|  xml inst |
	xml := self example1.
	inst := Object readSixxFrom: xml.
	Transcript cr; show: self name, ' instance is load from XML...'; cr; show: inst.
	^inst

! !

!SixxCustomStoreLoadExample class methodsFor: 'examples' stamp: 'MU 6/14/2002 11:17'!
example3
	"SixxCustomStoreLoadExample example3"
	"Writing custom serialization class object"
	| cls xml |
	cls := SixxCustomStoreLoadExample.
	xml := cls sixxString.
	Transcript cr; show: self name, ' class instance sixx is...'; cr; show: xml.
	^xml

! !

!SixxCustomStoreLoadExample class methodsFor: 'examples' stamp: 'MU 6/14/2002 11:30'!
example4
	"SixxCustomStoreLoadExample example4"
	"Reading custom serialization object"
	| xml cls |
	xml := self example3.
	self instances: nil. "class instances variable is set to nil"
	cls := self readSixxFrom: xml.
	Transcript cr; show: self name, ' cls instance is load from XML...'; cr; show: cls.
	^self instances inspect. "now class instances variable has been set"

! !

!SixxCustomStoreLoadExample class methodsFor: 'instance creation' stamp: 'MU 6/9/2002 19:47'!
id: anInteger
	| inst |
	inst := self new id: anInteger; cachedData: thisContext; yourself.
	self instances add: inst.
	^inst! !

!SixxCustomStoreLoadExample class methodsFor: 'class initialization' stamp: 'MU 6/14/2002 11:25'!
initialize
	"SixxCustomStoreLoadExampleClass initialize"
	instances := OrderedCollection new.
	cachedData := thisContext. "some unstorable cache data"! !

!SixxCustomStoreLoadExample class methodsFor: 'accessing' stamp: 'MU 6/9/2002 19:16'!
instances
	instances isNil ifTrue: [instances := OrderedCollection new].
	^instances! !

!SixxCustomStoreLoadExample class methodsFor: 'accessing' stamp: 'MU 6/9/2002 19:17'!
instances: aValue
	instances := aValue! !

!SixxCustomStoreLoadExample class methodsFor: 'instance creation' stamp: 'MU 6/9/2002 19:50'!
random
	^self id: Random new next! !

!SixxCustomStoreLoadExample class methodsFor: 'sixx writing/reading' stamp: 'mu 8/2/2006 20:52'!
sixxContentOn: aStream indent: level context: dictionary 
	"override if you like"
	aStream cr.
	self instances
		sixxOn: aStream
		name: 'instances'
		indent: level + 1
		context: dictionary.
	aStream tab: level! !

!SixxCustomStoreLoadExample class methodsFor: 'sixx writing/reading' stamp: 'MU 7/3/2002 00:33'!
sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	instVarName asString = 'instances' ifTrue: [self instances: aValue]! !

!SixxCustomStoreLoadExample methodsFor: 'accessing' stamp: 'MU 6/9/2002 19:41'!
cachedData
	^cachedData! !

!SixxCustomStoreLoadExample methodsFor: 'accessing' stamp: 'MU 6/9/2002 19:42'!
cachedData: aValue
	cachedData := aValue! !

!SixxCustomStoreLoadExample methodsFor: 'accessing' stamp: 'MU 6/9/2002 18:33'!
id
	^id! !

!SixxCustomStoreLoadExample methodsFor: 'accessing' stamp: 'MU 6/9/2002 18:33'!
id: anInteger
	id := anInteger! !

!SixxCustomStoreLoadExample methodsFor: 'sixx writing/reading' stamp: 'mu 7/27/2006 17:49'!
sixxIgnorableInstVarNames
	^#('cachedData')! !

Object subclass: #SixxExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Examples'!

!SixxExamples commentStamp: '<historical>' prior: 0!
SIXX basic examples: see class side.
---
MU 6/14/2002 11:12!

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/9/2002 02:10'!
example1
	"SixxExamples example1"
	"Create a SIXX string from an object (like #storeString)"
	
	| dict array xmlString |
	dict := Dictionary new.
	dict at: #Smalltalk put: 'Best'.
	dict at: #Ruby put: 'Cool'.
	dict at: #Java put: 'Forget it'.
	array := Array new:3.
	array at: 1 put: 'Language Impressions'.
	array at: 2 put: dict.
	array at: 3 put: Date today.
	xmlString := array sixxString.
	Transcript cr; show: '##This is sixx xml instance##'. 
	Transcript cr; show: xmlString.
	
	^xmlString ! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/9/2002 02:53'!
example2
	"SixxExamples example2"
	"Read a SIXX string and restore an instance (like #readFrom:)"
	
	| xmlString obj |
	xmlString := SixxExamples example1.
	obj := Object readSixxFrom: xmlString.
	obj inspect. ! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/9/2002 02:35'!
example3
	"SixxExamples example3"
	"Resolve circular and shared objects"
	
	| rootOrdered sharedDict subOrdered subArray xmlString obj |
	rootOrdered := OrderedCollection new.
	sharedDict := Dictionary new.
	sharedDict at: #hello put: 'Hello'.
	sharedDict at: #recurHello put: sharedDict.
	subOrdered := OrderedCollection new.
	subOrdered add: sharedDict.
	subOrdered add: Time now.
	subArray := Array new: 2.
	subArray at: 1 put: sharedDict.
	subArray at: 2 put: Date today.
	rootOrdered add: subOrdered; add: subArray.
	
	xmlString := rootOrdered sixxString.
	Transcript cr; show: '##This is sixx xml instance##'. 
	Transcript cr; show: xmlString.
	
	obj := Object readSixxFrom: xmlString.
	Transcript cr; show: '##Shared object comparison##'. 
	Transcript cr; show: obj first first = obj last first.
	obj inspect. 
	
	
	

! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/9/2002 02:36'!
example4
	"SixxExamples example4"
	"Save and load Preferences data"
	
	| preferences |
	preferences := Preferences allPreferenceObjects sixxString.
	preferences := Object readSixxFrom: preferences.
	^preferences inspect.

	

! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/14/2002 11:56'!
example5
	"SixxExamples example5"
	"Write object data to an external file"
	
	| sws |
	sws := SixxWriteStream newFileNamed: ('obj.sixx').
	sws nextPut: Color random.
	sws nextPut: Rectangle fromUser.
	sws nextPut: View subclasses.
	sws nextPutAll: View subclasses. "note the differences"
	sws close.
! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 6/9/2002 02:45'!
example6
	"SixxExamples example6"
	"Read object data from an external file"
	
	| srs objects |
	srs := SixxReadStream readOnlyFileNamed: ('obj.sixx').
	objects := OrderedCollection new.
	[srs atEnd] whileFalse: [objects add: srs next].
	srs close.
	objects inspect.
! !

!SixxExamples class methodsFor: 'examples' stamp: 'MU 9/19/2002 00:45'!
example7
	"SixxExamples example7"

	"Write object data to an external file"

	| sws dic |
	sws := SixxWriteStream newFileNamed: 'obj2.sixx'.
	sws nextPut: Color red.
	sws nextPut: Rectangle fromUser.
	sws nextPut: true.
	sws nextPut: false.
	sws nextPut: $a.
	sws nextPut: $(.
	sws nextPut: (OrderedCollection with: 1 with: Date today).
	sws nextPut: Time now.
	sws nextPut: nil.
	sws nextPut: (ByteArray 
				with: 10
				with: 20
				with: 30).
	dic := Dictionary new.
	dic at: 'first' put: '111'.
	dic at: 'second' put: '222'.
	sws nextPut: dic.
	sws close! !

Object variableSubclass: #SixxMockBinaryData
	instanceVariableNames: 'author version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockBinaryData class methodsFor: 'instance creation' stamp: 'MU 10/21/2002 01:03'!
author: author version: version data: binaryData
	"SixxMockBinaryData author: 'MU' version: '0.1' data: #(1 2 3)"
	| inst idx |
	inst := self new: binaryData size.
	idx := 0.
	binaryData do: [:each | inst at: (idx := idx + 1) put: each].
	inst author: author.
	inst version: version.
	^inst

! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 22:58'!
author
	^author! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 22:59'!
author: aString
	author :=  aString
! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 22:59'!
version
	^version! !

!SixxMockBinaryData methodsFor: 'accessing' stamp: 'MU 10/20/2002 23:00'!
version: aString
	version :=  aString
! !

Object subclass: #SixxMockEnvelope
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockEnvelope class methodsFor: 'instance creation' stamp: 'mu 5/10/2002 17:48'!
header: aHeader
	super initialize.
	^ self new header: aHeader! !

!SixxMockEnvelope methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
header
	^ header! !

!SixxMockEnvelope methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
header: aHeader
	header := aHeader! !

Object subclass: #SixxMockFixedNewFailedClass
	instanceVariableNames: 'att1 att2 att3Block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

SixxMockFixedNewFailedClass subclass: #SixxMockFixedAlternativeClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockFixedAlternativeClass class methodsFor: 'instance creation' stamp: 'mu 6/24/2004 23:02'!
new
	"new is OK for me"
	^self basicNew! !

!SixxMockFixedNewFailedClass class methodsFor: 'instance creation' stamp: 'mu 6/24/2004 22:32'!
new
	^Error new signal: '#new should not be used!!'! !

!SixxMockFixedNewFailedClass class methodsFor: 'for tests' stamp: 'mu 6/24/2004 22:37'!
prototype1
	"self prototype1"
	| inst |
	inst := self basicNew.
	inst att1: 1.
	inst att2: 'TWO'.
	inst att3Block: [:this | 'is block'].
	^inst! !

!SixxMockFixedNewFailedClass class methodsFor: 'for tests' stamp: 'mu 6/24/2004 22:45'!
prototype2
	"self prototype2"
	| inst |
	inst := self basicNew.
	inst att1: 3.
	inst att2: 'Four'.
	inst att3Block: [:this :is | 'block2'].
	^inst! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:33'!
att1
	^att1! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:33'!
att1: aValue
	att1 := aValue! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:33'!
att2
	^att2! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:33'!
att2: aValue
	att2 := aValue! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:36'!
att3Block
	^att3Block! !

!SixxMockFixedNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/24/2004 22:36'!
att3Block: aValue
	att3Block := aValue! !

!SixxMockFixedNewFailedClass methodsFor: 'initializing-sixx' stamp: 'mu 6/24/2004 22:34'!
sixxInitialize
	att3Block := [:a :b | a < b].! !

Object subclass: #SixxMockHeader
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockHeader class methodsFor: 'instance creation' stamp: 'mu 5/10/2002 17:48'!
id: aString
	^ self new id: aString! !

!SixxMockHeader methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
id
	^ id! !

!SixxMockHeader methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
id: aString
	id := aString! !

Object subclass: #SixxMockSuperClassForUnitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

SixxMockSuperClassForUnitTest class
	instanceVariableNames: 'instVar1 instVar2'!

SixxMockSuperClassForUnitTest subclass: #SixxMockClassForUnitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

SixxMockClassForUnitTest class
	instanceVariableNames: 'instVar3'!

!SixxMockClassForUnitTest class methodsFor: 'class initialization' stamp: 'mu 5/10/2002 17:48'!
initialize
	"MockClassForUnitTest initialize"
	super initialize.
	instVar3 := nil.! !

!SixxMockClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
instVar3
	instVar3 isNil ifTrue: [instVar3 := ''].
	^instVar3! !

!SixxMockClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:48'!
instVar3: aString
	instVar3 := aString! !

!SixxMockSuperClassForUnitTest class methodsFor: 'class initialization' stamp: 'mu 5/10/2002 17:47'!
initialize
	"MockSuperClassForUnitTest initialize"
	super initialize.
	instVar1 := nil.
	instVar2 := nil.! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'kuri-t 6/10/2002 14:44'!
instVar1
	instVar1 isNil
		ifTrue: [instVar1 := ''].
	^ instVar1! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:47'!
instVar1: aString
	instVar1 := aString! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'kuri-t 6/10/2002 14:44'!
instVar2
	instVar2 isNil
		ifTrue: [instVar2 := ''].
	^ instVar2! !

!SixxMockSuperClassForUnitTest class methodsFor: 'accessing' stamp: 'mu 5/10/2002 17:47'!
instVar2: aString
	instVar2 := aString! !

Object subclass: #SixxMorphMemento
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Examples'!

!SixxMorphMemento commentStamp: '<historical>' prior: 0!
I am an example of SIXX custom serialization.
I am useful only in Squeak environment, because I write/read a morph in SIXX.

---
MU 6/14/2002 11:12!

!SixxMorphMemento class methodsFor: 'examples' stamp: 'MU 6/14/2002 12:34'!
example1
	"SixxMorphMemento example1"
	"Create a SIXX string from an StarMorph"

	| morph memento |
	morph := StarMorph new openInWorld.
	memento := SixxMorphMemento on: morph.
	^memento sixxString! !

!SixxMorphMemento class methodsFor: 'examples' stamp: 'MU 6/14/2002 12:34'!
example2
	"SixxMorphMemento example2"
	"Read a SIXX string and restore a StarMorph. Original StarMorph is still there"

	| xmlMorphString memento morph |
	xmlMorphString := self example1.
	memento := Object readSixxFrom: xmlMorphString.
	morph := memento morph.
	morph openInWorld.
	morph color: Color random.
	morph position: (morph position + (20@20)).
	^morph! !

!SixxMorphMemento class methodsFor: 'examples' stamp: 'MU 6/14/2002 13:30'!
example3
	"SixxMorphMemento example3"
	"Write object data to an external file"

	| sws  |
	sws := SixxWriteStream newFileNamed: ('morph.sixx').
	sws nextPut: (SixxMorphMemento on: (BouncingAtomsMorph new position: 200@200)).
	sws close.! !

!SixxMorphMemento class methodsFor: 'examples' stamp: 'MU 6/14/2002 12:37'!
example4
	"SixxMorphMemento example4"
	"Read a Mprph from an external file"

	| srs memento morph |
	srs := SixxReadStream readOnlyFileNamed: ('morph.sixx').
	memento := srs next.
	srs close.
	morph := memento morph.
	morph openInWorld.
	morph inspect.! !

!SixxMorphMemento class methodsFor: 'instance creation' stamp: 'MU 6/14/2002 11:52'!
on: aMorph
	^self new morph: aMorph; yourself! !

!SixxMorphMemento methodsFor: 'accessing' stamp: 'MU 6/14/2002 11:33'!
morph
	^morph! !

!SixxMorphMemento methodsFor: 'private' stamp: 'MU 6/14/2002 12:28'!
morphForStore
	| file con |
	self morph allMorphsDo: [:m | m prepareToBeSaved].
	file := RWBinaryOrTextStream on: (ByteArray new: 5000).
	file binary.
	(self streamClass on: file)	nextPut: self morph.
	con := Base64MimeConverter mimeEncode: file reset.
	file close.
	^con contents
! !

!SixxMorphMemento methodsFor: 'private' stamp: 'MU 6/14/2002 12:27'!
morphFrom: aString
	| byteStr oStr |
	byteStr := (Base64MimeConverter mimeDecodeToBytes: (ReadStream on: aString)).
	oStr := self streamClass on: byteStr.
	^oStr next
! !

!SixxMorphMemento methodsFor: 'accessing' stamp: 'MU 6/14/2002 11:33'!
morph: aMorph
	morph := aMorph! !

!SixxMorphMemento methodsFor: 'writing/reading sixx' stamp: 'MU 6/14/2002 11:54'!
sixxContentOn: aStream indent: level context: dictionary 
	"override if you like"
	aStream cr.
	self morphForStore
		sixxOn: aStream
		name: 'morph'
		indent: level + 1
		context: dictionary.
	aStream tab: level! !

!SixxMorphMemento methodsFor: 'writing/reading sixx' stamp: 'MU 6/14/2002 12:09'!
sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	instVarName = 'morph' ifTrue: [self morph: (self morphFrom: aValue)]! !

!SixxMorphMemento methodsFor: 'factory' stamp: 'MU 6/14/2002 12:27'!
streamClass
	^ReferenceStream! !

Object subclass: #SixxPortableUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Squeak'!

SixxPortableUtil class
	instanceVariableNames: 'setting'!

!SixxPortableUtil class methodsFor: 'actions' stamp: 'mu 9/13/2006 13:02'!
charCodeOf: aCharacter
	^aCharacter asUnicode! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 3/18/2003 18:29'!
classAt: localClassName in: environmentQualifier 
	"#Squeak Specific#"
	| foundClass classNameSymbol |
	foundClass := nil.
	classNameSymbol := localClassName asSymbol.
	foundClass := self setting useEnvironment
				ifTrue: [| env | 
					env := environmentQualifier isNil
								ifTrue: [Smalltalk]
								ifFalse: ["Currently Squeak does not support  
									namespace, so just ignore"
									Smalltalk].
					env
						at: classNameSymbol
						ifAbsent: []]
				ifFalse: [Smalltalk
						at: classNameSymbol
						ifAbsent: []].
	^ foundClass! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 3/6/2003 15:55'!
environmentQualifierOf: aClass
	"#Squeak Specific#"
	"Currently Squeak does not support namespace, so just ignore"
	^'Smalltalk'! !

!SixxPortableUtil class methodsFor: 'class initialization' stamp: 'MU 3/18/2003 18:27'!
initialize
	setting := nil! !

!SixxPortableUtil class methodsFor: 'class initialization' stamp: 'MU 3/18/2003 18:32'!
obsolete
	self initialize! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 6/11/2002 12:29'!
readFileStreamNamed: aFilename
	"#Squeak Specific#"
	^CrLfFileStream readOnlyFileNamed: aFilename.! !

!SixxPortableUtil class methodsFor: 'accessing' stamp: 'MU 3/18/2003 18:32'!
setting
	setting isNil
		ifTrue: [setting := Smalltalk
						at: #SixxSetting
						ifAbsent: [self error: 'SixxSetting is needed to run SIXX']].
	^ setting! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 6/11/2003 17:26'!
signalException: anException
	"#Squeak Specific#"

	^anException signal! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 6/11/2002 12:35'!
writeFileStreamNamed: aFilename
	"#Squeak Specific#"
	^CrLfFileStream newFileNamed: aFilename.! !

Object subclass: #SixxReadStream
	instanceVariableNames: 'stream sixxElements contextDictionary position limit cachedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxReadStream commentStamp: '<historical>' prior: 0!
I represent a ReadStream for SIXX format.

I can be used as follows:

srs := SixxReadStream readOnlyFileNamed: ('obj.sixx').
obj := srs next.
srs close.
obj inspect.

srs := SixxReadStream readOnlyFileNamed: ('objs.sixx').
objs := srs contents.
srs close.
objs inspect.

---
[:masashi | ^umezawa]!

!SixxReadStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/21/2002 15:23'!
new
	self error: 'Streams are created with on:'! !

!SixxReadStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/31/2002 16:42'!
on: readStream 
	^ self basicNew on: readStream! !

!SixxReadStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/21/2002 15:22'!
readOnlyFileNamed: fileName 
	^ self basicNew readOnlyFileNamed: fileName! !

!SixxReadStream methodsFor: 'testing' stamp: 'kuri-t 5/20/2002 18:54'!
atEnd
	^ self position >= self limit! !

!SixxReadStream methodsFor: 'accessing' stamp: 'kuri-t 5/31/2002 16:51'!
cachedObjects
	^ cachedObjects! !

!SixxReadStream methodsFor: 'private' stamp: 'kuri-t 5/21/2002 11:29'!
checkSixxElement: sixxElement 
	(SixxXmlUtil nameFrom: sixxElement)
			= 'sixx'
		ifFalse: [self error: 'unexpected element: '
					, (SixxXmlUtil nameFrom: sixxElement)]! !

!SixxReadStream methodsFor: 'file open/close' stamp: 'MU 5/31/2002 12:09'!
close
	self stream close! !

!SixxReadStream methodsFor: 'reading' stamp: 'MU 6/7/2002 18:08'!
contents
	^(self next: self size) asArray! !

!SixxReadStream methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 15:14'!
contextDictionary
	^ contextDictionary! !

!SixxReadStream methodsFor: 'private-recovery' stamp: 'MU 5/24/2003 18:39'!
findStringIndexes: subString from: sourceString 
	| foundIndexes index |
	foundIndexes := OrderedCollection new.
	index := 1.
	[index = 0]
		whileFalse: [index := sourceString findString: subString startingAt: index.
			index = 0
				ifFalse: [foundIndexes add: index.
					index := index + 1]].
	^ foundIndexes! !

!SixxReadStream methodsFor: 'initializing' stamp: 'kuri-t 5/31/2002 17:16'!
initialize
	contextDictionary := IdentityDictionary new.
	position := 0.
	sixxElements := self parseStream: stream.
	limit := sixxElements isNil
				ifTrue: [0]
				ifFalse: [sixxElements size].
	cachedObjects := Dictionary new! !

!SixxReadStream methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 15:16'!
limit
	^ limit! !

!SixxReadStream methodsFor: 'reading' stamp: 'kuri-t 5/31/2002 17:25'!
next
	^ self atEnd
		ifFalse: [position := position + 1. self cachedObjects
						at: position
						ifAbsentPut: [self
								readSixxFromSixxElement: (sixxElements at: position)]]! !

!SixxReadStream methodsFor: 'reading' stamp: 'MU 5/31/2002 12:29'!
next: anInteger 
	| ord |
	anInteger < 0 ifTrue: [^nil].
	ord := OrderedCollection new: anInteger.
	anInteger
		timesRepeat: [self atEnd
				ifFalse: [ord add: self next]].
	^ ord! !

!SixxReadStream methodsFor: 'initializing' stamp: 'MU 5/31/2002 12:03'!
on: aStream 
	stream := aStream.
	self initialize! !

!SixxReadStream methodsFor: 'private' stamp: 'MU 6/11/2003 17:23'!
parseStream: aStream 
	| root str recoverTried |
	(aStream isNil or: [aStream size = 0])	ifTrue: [^nil].
	str := aStream.
	recoverTried := false.
	[root := SixxXmlUtil parseXml: str]
		on: SixxXmlParseError do: [:ex | (SixxSetting useRecoveryRead and: [recoverTried not])
			ifTrue: 
				[str := self recoveredStreamFrom: str.
				recoverTried := true.
				ex retry]
			ifFalse: [ex pass]].
	self checkSixxElement: root.
	^SixxXmlUtil elementsFrom: root! !

!SixxReadStream methodsFor: 'reading' stamp: 'MU 5/31/2002 12:36'!
peek
	| nextObj |
	nextObj := self next.
	self privatePosition: self position - 1.
	^ nextObj! !

!SixxReadStream methodsFor: 'reading' stamp: 'kuri-t 5/21/2002 15:14'!
position
	^ position! !

!SixxReadStream methodsFor: 'reading' stamp: 'kuri-t 5/31/2002 16:32'!
position: anInteger 
	(anInteger < 0
			and: [anInteger > limit])
		ifTrue: [self error: 'out of bounds'].
	self reset.
	self next: anInteger! !

!SixxReadStream methodsFor: 'private-accessing' stamp: 'MU 5/31/2002 14:45'!
privatePosition: anInteger 
	
	position := anInteger! !

!SixxReadStream methodsFor: 'initializing' stamp: 'MU 6/11/2002 12:29'!
readOnlyFileNamed: fileName 
	stream := SixxPortableUtil readFileStreamNamed: fileName.
	self initialize! !

!SixxReadStream methodsFor: 'private' stamp: 'kuri-t 5/20/2002 16:51'!
readSixxFromSixxElement: sixxElement 
	^ Object readSixxFromSixxElement: sixxElement context: self contextDictionary! !

!SixxReadStream methodsFor: 'private-recovery' stamp: 'MU 5/24/2003 19:05'!
recoveredStreamFrom: aStream 
	| contents startIndexes endIndexes recoverStream |
	contents := aStream contents.

	startIndexes := self findStringIndexes: '<sixx.object' from: contents.
	endIndexes := self findStringIndexes: '</sixx.object>' from: contents.

	recoverStream := ReadWriteStream with: (contents copyFrom: 1 to: (startIndexes last -1)).
	(startIndexes size - endIndexes size -1) timesRepeat: [recoverStream nextPutAll: '</sixx.object>'].
	recoverStream nextPutAll: '</sixx>'.

	^ recoverStream reset! !

!SixxReadStream methodsFor: 'reading' stamp: 'MU 5/31/2002 12:36'!
reset
	self privatePosition: 0! !

!SixxReadStream methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 15:15'!
sixxElements
	^ sixxElements! !

!SixxReadStream methodsFor: 'reading' stamp: 'kuri-t 5/21/2002 11:54'!
size
	^ self limit! !

!SixxReadStream methodsFor: 'reading' stamp: 'kuri-t 5/31/2002 16:06'!
skip: anInteger
	self position: self position + anInteger.! !

!SixxReadStream methodsFor: 'accessing' stamp: 'kuri-t 5/17/2002 15:25'!
stream
	^ stream! !

Object subclass: #SixxSetting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

SixxSetting class
	instanceVariableNames: 'useCDATA useEnvironment useRecoveryRead'!

!SixxSetting class methodsFor: 'accessing' stamp: 'MU 9/2/2002 02:26'!
useCDATA
	useCDATA isNil ifTrue: [useCDATA := false].
	^useCDATA! !

!SixxSetting class methodsFor: 'accessing' stamp: 'MU 9/2/2002 02:26'!
useCDATA: aBoolean
	useCDATA := aBoolean! !

!SixxSetting class methodsFor: 'accessing' stamp: 'MU 3/6/2003 12:55'!
useEnvironment
	useEnvironment isNil ifTrue: [useEnvironment := false].
	^useEnvironment! !

!SixxSetting class methodsFor: 'accessing' stamp: 'MU 3/6/2003 12:55'!
useEnvironment: aBoolean
	useEnvironment := aBoolean! !

!SixxSetting class methodsFor: 'accessing' stamp: 'mu 2/7/2006 21:15'!
useNcr
	^SixxXmlUtil useNcr! !

!SixxSetting class methodsFor: 'accessing' stamp: 'mu 2/7/2006 21:15'!
useNcr: aBoolean
	^SixxXmlUtil useNcr: aBoolean! !

!SixxSetting class methodsFor: 'accessing' stamp: 'MU 5/24/2003 18:32'!
useRecoveryRead
	useRecoveryRead isNil ifTrue: [useRecoveryRead := false].
	^useRecoveryRead! !

!SixxSetting class methodsFor: 'accessing' stamp: 'MU 5/24/2003 18:33'!
useRecoveryRead: aBoolean
	useRecoveryRead := aBoolean! !

Object subclass: #SixxWriteStream
	instanceVariableNames: 'stream contextDictionary isStartTagPut isEndTagPut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxWriteStream commentStamp: '<historical>' prior: 0!
I represent a WriteStream for SIXX format.

I can be used as follows:

srs := SixxWriteStream newFileNamed: ('obj.sixx').
srs nextPut: <object>.
srs close.

srs := SixxWriteStream newFileNamed: ('objs.sixx').
srs nextPutAll: <collection of object>.
srs close.

---
[:masashi | ^umezawa]!

!SixxWriteStream class methodsFor: 'instance creation' stamp: 'MU 5/31/2002 11:20'!
new
	^super new initialize! !

!SixxWriteStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/17/2002 12:29'!
newFileNamed: fileName 
	^ self new newFileNamed: fileName! !

!SixxWriteStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/31/2002 16:42'!
onWithDeclaration: writeStream 
	^ (self on: writeStream) xmlDeclaration! !

!SixxWriteStream class methodsFor: 'instance creation' stamp: 'kuri-t 5/31/2002 16:42'!
on: writeStream 
	^ self new on: writeStream! !

!SixxWriteStream methodsFor: 'file open/close' stamp: 'MU 5/31/2002 11:45'!
close
	self endTag.
	self stream close
! !

!SixxWriteStream methodsFor: 'actions' stamp: 'mu 7/30/2006 22:03'!
contents
	^self close; rawContents! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
contextDictionary

	^contextDictionary! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
contextDictionary: aValue

	contextDictionary := aValue! !

!SixxWriteStream methodsFor: 'writing' stamp: 'kuri-t 5/17/2002 13:56'!
cr
	self stream cr! !

!SixxWriteStream methodsFor: 'writing' stamp: 'MU 5/31/2002 12:00'!
endTag
	(self isStartTagPut and: [ self isEndTagPut not] )
		ifTrue: [self stream nextPutAll: SixxConstants sixxEndTag.
			self isEndTagPut: true]! !

!SixxWriteStream methodsFor: 'initializing' stamp: 'MU 5/31/2002 11:34'!
initialize
	contextDictionary := IdentityDictionary new.
	isStartTagPut := false.
	isEndTagPut := false. 
	! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
isEndTagPut

	^isEndTagPut! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
isEndTagPut: aValue

	isEndTagPut := aValue! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
isStartTagPut

	^isStartTagPut! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
isStartTagPut: aValue

	isStartTagPut := aValue! !

!SixxWriteStream methodsFor: 'initializing' stamp: 'MU 6/14/2002 11:59'!
newFileNamed: fileName 
	stream := SixxPortableUtil writeFileStreamNamed: fileName.
	self initialize! !

!SixxWriteStream methodsFor: 'writing' stamp: 'kuri-t 5/17/2002 14:31'!
nextPutAll: aCollection 
	aCollection
		do: [:obj | self nextPut: obj]! !

!SixxWriteStream methodsFor: 'writing' stamp: 'MU 5/31/2002 11:45'!
nextPut: anObject 
	self startTag.
	anObject
		sixxOn: self stream
		indent: 1
		context: self contextDictionary! !

!SixxWriteStream methodsFor: 'initializing' stamp: 'MU 5/31/2002 11:19'!
on: aStream
	stream := aStream.
	! !

!SixxWriteStream methodsFor: 'actions' stamp: 'MU 5/31/2002 11:53'!
rawContents
	^self stream contents
! !

!SixxWriteStream methodsFor: 'writing' stamp: 'MU 5/31/2002 11:52'!
startTag
	self isStartTagPut
		ifFalse: [self stream nextPutAll: SixxConstants sixxStartTag.
			self isStartTagPut: true.
			self cr]! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
stream

	^stream! !

!SixxWriteStream methodsFor: 'accessing' stamp: 'MU 5/31/2002 11:35'!
stream: aValue

	stream := aValue! !

!SixxWriteStream methodsFor: 'writing' stamp: 'MU 5/31/2002 11:48'!
xmlDeclaration
	self stream nextPutAll: SixxConstants xmlDeclaration; cr! !

Object subclass: #SixxXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-ParserAdapter'!

SixxXmlParserAdapter subclass: #SixxVwXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-ParserAdapter'!

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:48'!
attributeAt: attributeName from: sixxElement
	| attr |
	attr := sixxElement attributes
				detect: [:each | each key type = attributeName]
				ifNone: [^ nil].
	^ attr value! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:51'!
characterDataFrom: sixxElement
	^ sixxElement characterData! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'MU 5/23/2002 17:37'!
elementsFrom: sixxElement 
	^sixxElement elements select: [:each | each isText not]
! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 14:51'!
nameFrom: sixxElement 
	^ sixxElement tag type! !

!SixxVwXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 14:41'!
parseXml: xmlStringOrStream 
	| stream parser |
	stream := xmlStringOrStream isStream
				ifTrue: [xmlStringOrStream]
				ifFalse: [ReadStream on: xmlStringOrStream].
	parser := VWXMLXMLParser on: stream.
	parser validate: false.
	^ parser scanDocument root! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:46'!
attributeAt: attributeName from: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:51'!
characterDataFrom: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:46'!
elementsFrom: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'MU 5/23/2002 17:38'!
isTextFrom: sixxElement
	^ sixxElement isText! !

!SixxXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 19:23'!
nameFrom: sixxElement
	self subclassResponsibility! !

!SixxXmlParserAdapter class methodsFor: 'actions' stamp: 'kuri-t 5/16/2002 14:29'!
parseXml: xmlStringOrStream
	self subclassResponsibility! !

SixxXmlParserAdapter subclass: #SixxYaxoXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-ParserAdapter'!

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:44'!
attributeAt: attributeName from: sixxElement
	^ sixxElement attributeAt: attributeName! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/15/2002 17:51'!
characterDataFrom: sixxElement
	^ sixxElement contentString! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'MU 5/23/2002 17:38'!
elementsFrom: sixxElement 
	^sixxElement elements
		! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 14:53'!
nameFrom: sixxElement
	^ sixxElement name! !

!SixxYaxoXmlParserAdapter class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 14:41'!
parseXml: xmlStringOrStream 
	| stream |
	stream := xmlStringOrStream isStream
				ifTrue: [xmlStringOrStream]
				ifFalse: [ReadStream on: xmlStringOrStream].
	^ (XMLDOMParser parseDocumentFrom: stream) topElement! !

Object subclass: #SixxXmlUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

SixxXmlUtil class
	instanceVariableNames: 'convertCharDict parserAdapter useNcr'!

!SixxXmlUtil class methodsFor: 'actions' stamp: 'MU 4/19/2002 18:03'!
asXmlText: aString 
	|  wStr |
	wStr := WriteStream
				on: (String new: aString size).
	^(self writeXmlText: aString on: wStr) contents! !

!SixxXmlUtil class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 12:12'!
attributeAt: attributeName from: sixxElement 
	^ self parserAdapter attributeAt: attributeName from: sixxElement! !

!SixxXmlUtil class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 12:12'!
characterDataFrom: sixxElement
	^ self parserAdapter characterDataFrom: sixxElement! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'MU 4/19/2002 18:08'!
contentsWithXmlDeclaration: aString 
	| wStr |
	wStr := WriteStream
				on: (String new: 1024).
	wStr nextPutAll: self xmlDeclaration.
	2
		timesRepeat: [wStr nextPut: Character cr.
			wStr nextPut: Character lf].
	wStr nextPutAll: aString.
	^ wStr contents! !

!SixxXmlUtil class methodsFor: 'accessing' stamp: 'MU 4/19/2002 18:03'!
convertCharDict
	^convertCharDict! !

!SixxXmlUtil class methodsFor: 'private' stamp: 'mu 11/4/2006 10:15'!
convertWriteXmlText: aString on: aWriteStream
	| cDict wStr |
	cDict := self convertCharDict.
	wStr := aWriteStream.
	aString
		do: [:eachChar | 
			| val | 
			val := (SixxPortableUtil charCodeOf: eachChar).
			val >= 127
				ifTrue: [self writeUnicodeChar: eachChar on: wStr]
				ifFalse: [| conv | 
					conv := cDict
								at: val
								ifAbsent: [].
					conv isNil
						ifTrue: [wStr nextPut: eachChar]
						ifFalse: [wStr nextPutAll: conv]]].
	^wStr! !

!SixxXmlUtil class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 12:12'!
elementsFrom: sixxElement
	^ self parserAdapter elementsFrom: sixxElement! !

!SixxXmlUtil class methodsFor: 'private-initialize' stamp: 'MU 9/2/2002 02:07'!
initConvertCharDict
	convertCharDict := Dictionary new.
	0 to: 47 do: [:each | convertCharDict at: each put: '&#', each asString, ';'].
	convertCharDict 
		at: $& asciiValue put: '&amp;';
		at: $< asciiValue put: '&lt;';
		at: $> asciiValue put: '&gt;';
		at: $' asciiValue put: '&apos;';
		at: $" asciiValue put: '&quot;'.
	convertCharDict 
		removeKey: Character space asciiValue;
		removeKey: Character tab asciiValue;
		removeKey: Character cr asciiValue;
		removeKey: Character lf asciiValue.
	convertCharDict 
		removeKey: $/ asciiValue;
		removeKey: $- asciiValue;
		removeKey: $. asciiValue.! !

!SixxXmlUtil class methodsFor: 'class initialization' stamp: 'kuri-t 5/16/2002 12:03'!
initialize
	"SixxXmlUtil initialize"
	self initConvertCharDict.
	parserAdapter := nil! !

!SixxXmlUtil class methodsFor: 'actions-parse' stamp: 'kuri-t 5/16/2002 12:12'!
isTextFrom: sixxElement
	^ self parserAdapter isTextFrom: sixxElement! !

!SixxXmlUtil class methodsFor: 'actions-parse' stamp: 'kuri-t 5/20/2002 14:53'!
nameFrom: sixxElement 
	^ self parserAdapter nameFrom: sixxElement! !

!SixxXmlUtil class methodsFor: 'accessing' stamp: 'kuri-t 5/16/2002 12:09'!
parserAdapter
	parserAdapter isNil
		ifTrue: [parserAdapter := (self environment includesKey: #XMLDOMParser)
						ifTrue: [self environment at: #SixxYaxoXmlParserAdapter]
						ifFalse: [(self environment includesKey: #VWXMLXMLParser)
								ifTrue: [self environment at: #SixxVwXmlParserAdapter]]].
	^ parserAdapter! !

!SixxXmlUtil class methodsFor: 'accessing' stamp: 'kuri-t 5/16/2002 12:10'!
parserAdapter: aSixxXmlParserAdapter 
	parserAdapter := aSixxXmlParserAdapter! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'MU 6/11/2003 17:24'!
parseXml: xmlStringOrStream 
	^[self parserAdapter parseXml: xmlStringOrStream] on: Error
		do: [:ex | SixxPortableUtil signalException: (SixxXmlParseError originalError: ex)]! !

!SixxXmlUtil class methodsFor: 'accessing' stamp: 'mu 2/6/2006 22:36'!
useNcr
	useNcr ifNil: [useNcr _ false].
	^useNcr! !

!SixxXmlUtil class methodsFor: 'accessing' stamp: 'mu 2/6/2006 22:36'!
useNcr: aBoolean
	useNcr := aBoolean == true! !

!SixxXmlUtil class methodsFor: 'private' stamp: 'mu 2/16/2006 17:40'!
writeUnicodeChar: aCharacter on: aWriteStream 
	self useNcr
		ifTrue: [aWriteStream nextPutAll: '&#';
				 nextPutAll: (SixxPortableUtil charCodeOf: aCharacter) asString;
				 nextPut: $;]
		ifFalse: [aWriteStream nextPut: aCharacter]! !

!SixxXmlUtil class methodsFor: 'actions' stamp: 'MU 9/2/2002 02:24'!
writeXmlText: aString on: aWriteStream 
	SixxSetting useCDATA
		ifTrue: [aWriteStream nextPutAll: '<!![CDATA['.
			aWriteStream nextPutAll: aString.
			aWriteStream nextPutAll: ']]>']
		ifFalse: [self convertWriteXmlText: aString on: aWriteStream]! !

!IntegerArray class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:19'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^ col asIntegerArray! !

!IntegerArray methodsFor: '*sixx-printing' stamp: 'MU 6/29/2002 16:03'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

!Date class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:22'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Date methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 22:29'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!Date methodsFor: '*sixx-private' stamp: 'MU 9/16/2002 22:28'!
sixxContentString
	"Squeak Specific"
	^self printString! !

!Color class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:22'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Color methodsFor: '*sixx-printing' stamp: 'kuri-t 5/14/2002 14:19'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self storeString! !

TestCase subclass: #SixxAbstractTestCase
	instanceVariableNames: 'originalUseEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxAbstractTestCase methodsFor: 'running' stamp: 'MU 3/6/2003 15:49'!
setUp
	originalUseEnvironment := SixxSetting useEnvironment.
	SixxSetting useEnvironment: false! !

!SixxAbstractTestCase methodsFor: 'running' stamp: 'MU 3/6/2003 15:49'!
tearDown
	SixxSetting useEnvironment: originalUseEnvironment! !

SixxAbstractTestCase subclass: #SixxConstantsTestCase
	instanceVariableNames: 'oldSixxConstants'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxConstantsTestCase methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 19:12'!
oldSixxConstants
	^ oldSixxConstants! !

!SixxConstantsTestCase methodsFor: 'accessing' stamp: 'kuri-t 5/21/2002 19:13'!
oldSixxConstants: aSixxConstants
	oldSixxConstants := aSixxConstants! !

!SixxConstantsTestCase methodsFor: 'running' stamp: 'kuri-t 5/21/2002 19:14'!
setUp
	^ self oldSixxConstants: SixxConstants! !

!SixxConstantsTestCase methodsFor: 'running' stamp: 'kuri-t 5/21/2002 19:22'!
tearDown
	SixxConstants initialize.
	SixxConstants xmlVersion: self oldSixxConstants xmlVersion.
	SixxConstants xmlEncoding: self oldSixxConstants xmlEncoding.
	SixxConstants sixxVersion: self oldSixxConstants sixxVersion! !

!SixxConstantsTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 13:56'!
testInitialize
	SixxConstants initialize.
	self
		should: [SixxConstants xmlVersion = '1.0'].
	self
		should: [SixxConstants xmlEncoding = 'utf-8'].
	self
		should: [SixxConstants sixxVersion = '1.0']! !

!SixxConstantsTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 13:59'!
testSixxStartTag
	SixxConstants initialize.
	self
		should: [SixxConstants sixxStartTag = '<sixx sixx.version="1.0">'].
	SixxConstants sixxVersion: '2.0'.
	self
		should: [SixxConstants sixxStartTag = '<sixx sixx.version="2.0">']! !

!SixxConstantsTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:00'!
testXmlDeclaration
	SixxConstants initialize.
	self
		should: [SixxConstants xmlDeclaration = '<?xml version="1.0" encoding="utf-8"?>'].
	SixxConstants xmlVersion: '3.0'.
	SixxConstants xmlEncoding: 'sjis'.
	self
		should: [SixxConstants xmlDeclaration = '<?xml version="3.0" encoding="sjis"?>']! !

SixxAbstractTestCase subclass: #SixxGeneratingTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:01'!
testSixxStringForArray
	| arr expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	arr := Array new: 3.
	arr at: 1 put: 10.
	arr at: 2 put: 20.
	arr at: 3 put: 30.
	self
		should: [arr sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 01:40'!
testSixxStringForBag
	| bag result |
	bag := Bag new.
	bag add: 10.
	bag add: 20.
	bag add: 30.
	bag add: 30.
	result := Object readSixxFrom: bag sixxString.
	self
		should: [result size = 4].
	self
		should: [result includes: 10].
	self
		should: [result includes: 20].
	self
		should: [result includes: 30].
	self
		should: [(result occurrencesOf: 30) = 2]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:01'!
testSixxStringForBoolean
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="True" >true</sixx.object>
'.
	self
		should: [true sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 6/26/2004 12:19'!
testSixxStringForByteArray
	| expectedStr |
	expectedStr :=  '<sixx.object sixx.id="0" sixx.type="ByteArray" >0A141E</sixx.object>
'.
	self
		should: [(ByteArray with: 10 with: 20 with: 30) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:02'!
testSixxStringForCharacter
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Character" >$A</sixx.object>
'.
	self
		should: [$A sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:05'!
testSixxStringForClass
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="SixxMockClassForUnitTest class" >
	<sixx.object sixx.id="1" sixx.name="instVar1" sixx.type="String" >value1</sixx.object>
	<sixx.object sixx.id="2" sixx.name="instVar2" sixx.type="String" >value2</sixx.object>
	<sixx.object sixx.id="3" sixx.name="instVar3" sixx.type="String" >value3</sixx.object>
</sixx.object>
'.
	SixxMockClassForUnitTest instVar1: 'value1'.
	SixxMockClassForUnitTest instVar2: 'value2'.
	SixxMockClassForUnitTest instVar3: 'value3'.
	self
		should: [SixxMockClassForUnitTest sixxString = expectedStr]
! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:06'!
testSixxStringForColor
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Color" >(Color r: 0.0 g: 0.0 b: 1.0)</sixx.object>
'.
	self
		should: [Color blue sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 7/3/2002 01:15'!
testSixxStringForCompositeDictionary
	| dic childDic expected |
	expected := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >parent1</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="String" >sample string.</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >parent4</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="Dictionary" >
			<sixx.object sixx.id="7" sixx.type="Association" >
				<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >child1</sixx.object>
				<sixx.object sixx.id="9" sixx.name="value" sixx.type="String" >abcde</sixx.object>
			</sixx.object>
		</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="10" sixx.type="Association" >
		<sixx.object sixx.id="11" sixx.name="key" sixx.type="Symbol" >parent3</sixx.object>
		<sixx.object sixx.id="12" sixx.name="value" sixx.type="Array" >
			<sixx.object sixx.id="13" sixx.type="SmallInteger" >10</sixx.object>
			<sixx.object sixx.id="14" sixx.type="SmallInteger" >20</sixx.object>
			<sixx.object sixx.id="15" sixx.type="SmallInteger" >30</sixx.object>
		</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="16" sixx.type="Association" >
		<sixx.object sixx.id="17" sixx.name="key" sixx.type="Symbol" >parent2</sixx.object>
		<sixx.object sixx.id="18" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
</sixx.object>
'.
	childDic := Dictionary new.
	childDic at: #child1 put: 'abcde'.
	dic := Dictionary new.
	dic at: #parent1 put: 'sample string.'.
	dic at: #parent2 put: 100.
	dic at: #parent3 put: #(10 20 30 ).
	dic at: #parent4 put: childDic.
	self
		should: [(Object readSixxFrom: dic sixxString) = (Object readSixxFrom: expected)]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:14'!
testSixxStringForDate
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Date" >14 May 2002</sixx.object>
'.
	self
		should: [(Date
				newDay: 14
				month: 5
				year: 2002) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 7/20/2006 15:57'!
testSixxStringForDateAndTime
	"self debug: #testSixxStringForDateAndTime"
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="DateAndTime" >2006-07-19T03:45:06+00:00</sixx.object>
'.
	self
		should: [(DateAndTime year: 2006 day: 200 hour: 3 minute: 45 second: 6) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 7/3/2002 01:13'!
testSixxStringForDictionary
	| dic expected |
	expected := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="String" >value2</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >key3</sixx.object>
		<sixx.object sixx.id="9" sixx.name="value" sixx.type="String" >value3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Dictionary new.
	dic at: #key1 put: 'value1'.
	dic at: #key2 put: 'value2'.
	dic at: #key3 put: 'value3'.
	self
		should: [(Object readSixxFrom: dic sixxString) = (Object readSixxFrom: expected)]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'minami 3/18/2003 01:36'!
testSixxStringForInterval
	| interval expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Interval" >(1 to: 10 by: 3)</sixx.object>
'.
	interval := 1 to: 10 by: 3.
	self should: [interval sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:18'!
testSixxStringForNumber
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Fraction" >(3/4)</sixx.object>
'.
	self
		should: [(3 / 4) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:18'!
testSixxStringForOrdredCollection
	| expectedStr col |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="OrderedCollection" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	col := OrderedCollection new.
	col add: 10.
	col add: 20.
	col add: 30.
	self
		should: [col sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 12/12/2006 19:47'!
testSixxStringForRectangle
	"SixxGeneratingTestCase debug: #testSixxStringForRectangle"
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Rectangle" >1@1 corner: 3@4</sixx.object>
'.
	self
		should: [(1@1 corner: 3@4) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 7/22/2002 00:08'!
testSixxStringForRunArray
	| arr expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="RunArray" >
	<sixx.object sixx.id="1" sixx.name="runs" sixx.type="Array" >
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="values" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.

	arr := RunArray runs: #(1 2 1) values: #(1 2 3).
	self should: [arr sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 01:42'!
testSixxStringForSet
	| set result |
	set := Set new.
	set add: 10.
	set add: 20.
	set add: 30.
	set add: 30.
	result := Object readSixxFrom: set sixxString.
	self
		should: [result size = 3].
	self
		should: [result includes: 10].
	self
		should: [result includes: 20].
	self
		should: [result includes: 30].
	! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:19'!
testSixxStringForSimpleObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Object" >
</sixx.object>
'.
	self
		should: [Object new sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:20'!
testSixxStringForString
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="String" >Hi&#44; I&apos;m String-object</sixx.object>
'.
	self
		should: ['Hi, I''m String-object' sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 9/2/2002 02:37'!
testSixxStringForStringUsingCDATA
	| originalSetting expectedStr |
	[originalSetting := SixxSetting useCDATA.
	SixxSetting useCDATA: true.
	expectedStr := '<sixx.object sixx.id="0" sixx.type="String" ><!![CDATA[Hi, I''m String-object.
How are you?
]]></sixx.object>
'.
	self
		should: ['Hi, I''m String-object.
How are you?
' sixxString = expectedStr]]
		ensure: [SixxSetting useCDATA: originalSetting]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 6/11/2003 17:44'!
testSixxStringForTime
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Time" >' 
				, (Time readFrom: '1:30:59 pm' readStream) sixxContentString , '</sixx.object>
'.
	self 
		should: [(Time readFrom: '1:30:59 pm' readStream) sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:22'!
testSixxStringForUndefinedObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="UndefinedObject" >nil</sixx.object>
'.
	self
		should: [nil sixxString = expectedStr]! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 04:37'!
testSixxStringForVariableObject
	| expectedStr variableObj |
	expectedStr :='<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >1</sixx.object>
	<sixx.object sixx.id="4" sixx.type="SmallInteger" >2</sixx.object>
	<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
</sixx.object>
'.
	
	variableObj := SixxMockBinaryData author: 'MU' version: '0.1' data: #(1 2 3).
	self
		should: [variableObj sixxString = expectedStr].
	
	! !

!SixxGeneratingTestCase methodsFor: 'tests' stamp: 'MU 10/27/2002 18:34'!
testSixxStringForVariableObjectNoData
	| expectedStr variableObj |
	
	expectedStr := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
</sixx.object>
'.

	variableObj := SixxMockBinaryData author: 'MU' version: '0.1' data: #().
	self
		should: [variableObj sixxString = expectedStr].
! !

SixxAbstractTestCase subclass: #SixxLoadingTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:23'!
testReadSixxForArray
	| sixxString arr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	arr := Object readSixxFrom: sixxString.
	self
		should: [arr size = 3].
	self
		should: [(arr at: 1)
				= 10].
	self
		should: [(arr at: 2)
				= 20].
	self
		should: [(arr at: 3)
				= 30]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:23'!
testReadSixxForBag
	| sixxString bag |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Bag" >
	<sixx.object sixx.id="1" sixx.type="String" >abcd</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.idref="2" ></sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
</sixx.object>
'.
	bag := Object readSixxFrom: sixxString.
	self
		should: [bag size = 4].
	self
		should: [(bag occurrencesOf: 10)
				= 2].
	self
		should: [(bag occurrencesOf: 'abcd')
				= 1].
	self
		should: [(bag occurrencesOf: #(10 20 ))
				= 1]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:25'!
testReadSixxForBoolean
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="True" >true</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= true]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 6/26/2004 12:18'!
testReadSixxForByteArray
	| sixxString byteArr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="ByteArray" >0A141E</sixx.object>
'.
	byteArr := Object readSixxFrom: sixxString.
	self
		should: [byteArr size = 3].
	self
		should: [(byteArr at: 1)
				= 10].
	self
		should: [(byteArr at: 2)
				= 20].
	self
		should: [(byteArr at: 3)
				= 30]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:29'!
testReadSixxForCharacter
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Character" >$A</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= $A]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:31'!
testReadSixxForClass
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockClassForUnitTest class" >
	<sixx.object sixx.id="1" sixx.name="instVar1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.name="instVar2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.name="instVar3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	SixxMockClassForUnitTest instVar1: 0;
		 instVar2: 0;
		 instVar3: 0.
	self
		should: [SixxMockClassForUnitTest instVar1 = 0].
	self
		should: [SixxMockClassForUnitTest instVar2 = 0].
	self
		should: [SixxMockClassForUnitTest instVar3 = 0].
	Object readSixxFrom: sixxString.
	self
		should: [SixxMockClassForUnitTest instVar1 = 10].
	self
		should: [SixxMockClassForUnitTest instVar2 = 20].
	self
		should: [SixxMockClassForUnitTest instVar3 = 30]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:32'!
testReadSixxForColor
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Color" >(Color r: 0.0 g: 0.0 b: 1.0)</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= Color blue]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:33'!
testReadSixxForCompositeObject
	| sixxString slipObj headerObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockEnvelope" >
	<sixx.object sixx.id="1" sixx.name="header" sixx.type="SixxMockHeader" >
		<sixx.object sixx.id="2" sixx.name="id" sixx.type="String" >99</sixx.object>
	</sixx.object>
</sixx.object>
'.
	slipObj := Object readSixxFrom: sixxString.
	headerObj := slipObj header.
	self
		should: [headerObj id = '99']! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 5/26/2003 11:17'!
testReadSixxForCorruptRecursiveDictionary
	| originalRecoveryRead |
	[ |  sixxString |
	originalRecoveryRead := SixxSetting useRecoveryRead.
	SixxSetting useRecoveryRead: false.
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object six
'.
	self should:[ Object readSixxFrom: sixxString] raise: SixxXmlParseError.
	
	] ensure: [SixxSetting useRecoveryRead: originalRecoveryRead]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:34'!
testReadSixxForDate
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Date" >14 May 2002</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (Date
						newDay: 14
						month: 5
						year: 2002)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 7/20/2006 15:59'!
testReadSixxForDateAndTime
	"self debug: #testReadSixxForDateAndTime"
	| sixxString |
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="DateAndTime" >2006-07-19T03:45:06+00:00</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (DateAndTime year: 2006 day: 200 hour: 3 minute: 45 second: 6)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 12/12/2006 19:22'!
testReadSixxForDateAndTimeOldFormat
	"self debug: #testReadSixxForDateAndTimeOldFormat"
	| sixxString |
	sixxString :=   '<sixx.object sixx.id="0" sixx.type="DateAndTime" sixx.env="Smalltalk" >
	<sixx.object sixx.id="1" sixx.name="seconds" sixx.type="SmallInteger" sixx.env="Smalltalk" >68952</sixx.object>
	<sixx.object sixx.id="2" sixx.name="offset" sixx.type="Duration" sixx.env="Smalltalk" >
		<sixx.object sixx.id="3" sixx.name="nanos" sixx.type="SmallInteger" sixx.env="Smalltalk" >0</sixx.object>
		<sixx.object sixx.idref="3" sixx.name="seconds" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="jdn" sixx.type="SmallInteger" sixx.env="Smalltalk" >2454082</sixx.object>
	<sixx.object sixx.idref="3" sixx.name="nanos" ></sixx.object>
</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (DateAndTime year: 2006 day: 346 hour: 19 minute: 9 second: 12)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:35'!
testReadSixxForDictionary
	| sixxString dic |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Object readSixxFrom: sixxString.
	self
		should: [dic size = 2].
	self
		should: [(dic at: #key1)
				= 'value1'].
	self
		should: [(dic at: #key2)
				= 100]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'minami 3/18/2003 01:36'!
testReadSixxForInterval
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Interval" >(1 to: 10 by: 3)</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (1 to: 10 by: 3)]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 20:34'!
testReadSixxForPoint
	| sixxString |
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="Point" >1@3</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (1@3)].
			
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="Point" >123456789.0@-3.5</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (123456789.0@-3.5)].
			
		! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 12/12/2006 19:50'!
testReadSixxForRectangle
	"SixxLoadingTestCase debug: #testReadSixxForRectangle"
	| sixxString |
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="Rectangle" >1@1 corner: 3@4</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (1@1 corner: 3@4)].
			
	sixxString :=   '<sixx.object sixx.id="0" sixx.type="Rectangle" >-1@1.234 corner: 3.456@5</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (-1@1.234 corner: 3.456@5)].
			
		! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 12/12/2006 19:51'!
testReadSixxForRectangleOldFormat
	"SixxLoadingTestCase debug: #testReadSixxForRectangleOldFormat"
	| sixxString |
	sixxString :=  '<sixx.object sixx.id="0" sixx.type="Rectangle" >
	<sixx.object sixx.id="1" sixx.name="origin" sixx.type="Point" >1@1</sixx.object>
	<sixx.object sixx.id="2" sixx.name="corner" sixx.type="Point" >3@4</sixx.object>
</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (1@1 corner: 3@4)].
			
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:37'!
testReadSixxForRecursiveArray
	| sixxString arr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	arr := Object readSixxFrom: sixxString.
	self
		should: [arr size = 3].
	self
		should: [(arr at: 1)
				= 10].
	self
		should: [(arr at: 2)
				= 20].
	self
		should: [(arr at: 3)
				== arr]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:38'!
testReadSixxForRecursiveDictionary
	| sixxString dic |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >key3</sixx.object>
		<sixx.object sixx.idref="0" sixx.name="value" ></sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Object readSixxFrom: sixxString.
	self
		should: [dic size = 3].
	self
		should: [(dic at: #key1)
				= 'value1'].
	self
		should: [(dic at: #key2)
				= 100].
	self
		should: [(dic at: #key3)
				== dic]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 7/22/2002 00:06'!
testReadSixxForRunArray
	| sixxString runArray |
	sixxString := '<sixx.object sixx.id="0" sixx.type="RunArray" >
	<sixx.object sixx.id="1" sixx.name="runs" sixx.type="Array" >
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="values" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	runArray := Object readSixxFrom: sixxString.

	self should: [runArray runs = #(1 2 1)].
	self should: [runArray values = #(1 2 3)]
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:39'!
testReadSixxForSimpleObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockHeader" >
	<sixx.object sixx.id="1" sixx.name="id" sixx.type="String" >1000</sixx.object>
</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString) id = '1000']! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 9/2/2002 02:43'!
testReadSixxForStringUsingCDATA
	| originalSetting sixxString string |
	[originalSetting := SixxSetting useCDATA.
	SixxSetting useCDATA: true.
	sixxString := '<sixx.object sixx.id="0" sixx.type="String" ><!![CDATA[Hi, I''m String-object.
How are you?
]]></sixx.object>
'.
	string := Object readSixxFrom: sixxString.
	self
		should: [string = 'Hi, I''m String-object.
How are you?
']]
		ensure: [SixxSetting useCDATA: originalSetting]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:39'!
testReadSixxForTime
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Time" >4:10:32 pm</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= (Time
						readFrom: (ReadStream on: '4:10:32 pm'))]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:43'!
testReadSixxForUndefinedObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="UndefinedObject" >nil</sixx.object>
'.
	self
		should: [(Object readSixxFrom: sixxString)
				= nil]! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 02:12'!
testReadSixxForVariableObject
	| sixxString variableObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >1</sixx.object>
	<sixx.object sixx.id="4" sixx.type="SmallInteger" >2</sixx.object>
	<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
</sixx.object>
'.
	
	variableObj := Object readSixxFrom: sixxString.
	self should: [ variableObj author = 'MU'].
	self should: [ variableObj version = '0.1'].
	self should: [ variableObj size = 3].
	self should: [ (variableObj at: 1) = 1].
	self should: [ (variableObj at: 2) = 2].
	self should: [ (variableObj at: 3) = 3].
	
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'MU 10/27/2002 18:32'!
testReadSixxForVariableObjectNoData
	
	| sixxString variableObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockBinaryData" >
	<sixx.object sixx.id="1" sixx.name="author" sixx.type="String" >MU</sixx.object>
	<sixx.object sixx.id="2" sixx.name="version" sixx.type="String" >0.1</sixx.object>
</sixx.object>
'.
	variableObj := Object readSixxFrom: sixxString.
	self should: [ variableObj author = 'MU'].
	self should: [ variableObj version = '0.1'].
	self should: [ variableObj size = 0].

	
	! !

!SixxLoadingTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:43'!
testReadSixxWithClassDoesNotExist
	| str catched |
	str := '<sixx.object sixx.id="0" sixx.type="doesNotExistString" >abcde</sixx.object>
'.
	self
		should: [(Object readSixxFrom: str)
				= nil].
	catched := false.
	self
		should: [[Object readSixxFrom: str]
				on: SixxClassNotFound
				do: [:ex | catched := true].
			catched]! !

SixxAbstractTestCase subclass: #SixxNamespaceSupportTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxNamespaceSupportTestCase methodsFor: 'running' stamp: 'MU 3/25/2003 02:35'!
setUp
	originalUseEnvironment := SixxSetting useEnvironment.
	SixxSetting useEnvironment: true! !

!SixxNamespaceSupportTestCase methodsFor: 'running' stamp: 'MU 3/25/2003 02:35'!
tearDown
	SixxSetting useEnvironment: originalUseEnvironment! !

!SixxNamespaceSupportTestCase methodsFor: 'tests' stamp: 'MU 3/25/2003 02:36'!
testNamespacedArray
	"self debug: #testNamespacedArray"
	| arraySixx1 array1  arraySixx2 array2  |
	arraySixx1 :=  '<sixx.object sixx.id="0" sixx.type="Array" sixx.env="Core" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" sixx.env="Core" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" sixx.env="Core" >20</sixx.object>
</sixx.object>
'.
	array1 := Object readSixxFrom: arraySixx1.
	self should: [array1 = #(10 20)].
	
	arraySixx2 := array1 sixxString. 
	array2 := Object readSixxFrom: arraySixx2.
	self should: [array2 = #(10 20)]! !

SixxAbstractTestCase subclass: #SixxNewFailedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxNewFailedTestCase methodsFor: 'tests' stamp: 'mu 6/24/2004 22:54'!
testWriteReadNewFailedClass
	| original sixxString read |
	original := SixxMockFixedNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 =  'TWO']. 
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := Object readSixxFrom: sixxString.
	self should: [read att1 = 1].
	self should: [read att2 =  'TWO'].
	self should: [read att3Block notNil].
	
	
	
	! !

!SixxNewFailedTestCase methodsFor: 'tests' stamp: 'mu 6/24/2004 23:04'!
testWriteReadNewFailedClassReciverAlternative
	| original sixxString read |
	original := SixxMockFixedNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 =  'TWO']. 
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := [Object readSixxFrom: sixxString] on: SixxNewFailed do: [:ex | ex resume: SixxMockFixedAlternativeClass].
	self should: [read class = SixxMockFixedAlternativeClass].
	self should: [read att1 = 1].
	self should: [read att2 =  'TWO'].
	self should: [read att3Block notNil].
	
	
	
	! !

!SixxNewFailedTestCase methodsFor: 'tests' stamp: 'mu 6/24/2004 23:10'!
testWriteReadNewVariableFailedClass
	| original sixxString read |
	original := SixxMockVariableNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 =  'TWO']. 
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := Object readSixxFrom: sixxString.
	self should: [read att1 = 1].
	self should: [read att2 =  'TWO'].
	self should: [read att3Block notNil].
	
	
	
	! !

!SixxNewFailedTestCase methodsFor: 'tests' stamp: 'mu 6/25/2004 00:59'!
testWriteReadNewVariableFailedClassReciverAlternative
	| original sixxString read |
	original := SixxMockVariableNewFailedClass prototype1.
	self should: [original att1 = 1].
	self should: [original att2 =  'TWO']. 
	self should: [original sixxString] raise: SixxInvalidSerialization.
	sixxString := original sixxString.
	
	self should: [Object readSixxFrom: sixxString] raise: SixxNewFailed.
	read := [Object readSixxFrom: sixxString] on: SixxNewFailed do: [:ex | ex resume: SixxMockVariableAlternativeClass].
	self should: [read class = SixxMockVariableAlternativeClass].
	self should: [read att1 = 1].
	self should: [read att2 =  'TWO'].
	self should: [read att3Block notNil].
	
	
	
	! !

SixxAbstractTestCase subclass: #SixxReadStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:46'!
testAtEnd
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = 'a'
				and: [stream atEnd not]].
	self
		should: [stream next = 'b'
				and: [stream atEnd not]].
	self
		should: [stream next = 'c'
				and: [stream atEnd]].
	self
		should: [stream next = nil
				and: [stream atEnd]]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:46'!
testCachedObjects
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	stream next; next.
	self
		should: [(stream cachedObjects at: 1)
				= 'a'].
	self
		should: [(stream cachedObjects at: 2)
				= 'b'].
	self
		shouldnt: [stream cachedObjects includesKey: 3].
	stream next.
	self
		should: [(stream cachedObjects at: 3)
				= 'c']! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:46'!
testNext
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = 'a'].
	self
		should: [stream next = 'b'].
	self
		should: [stream next = 'c'].
	self
		should: [stream next = nil]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:47'!
testNextMany
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [(stream next: 2)
				= (OrderedCollection with: 'a' with: 'b')].
	stream reset.
	self
		should: [(stream next: 5)
				= (OrderedCollection
						with: 'a'
						with: 'b'
						with: 'c')]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:48'!
testNextWithIdred
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Character" >$a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="Character" >$u</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
	<sixx.object sixx.idref="1" ></sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream next = $a].
	self
		should: [stream next = $u].
	self
		should: [stream next = $a].
	self
		should: [stream next = $u]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:48'!
testPeek
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream position = 0].
	self
		should: [stream peek = 'a'].
	self
		should: [stream position = 0].
	self
		should: [stream next = 'a']! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:49'!
testPosition
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	stream next: 3.
	self
		should: [stream position = 3].
	stream position: 1.
	self
		should: [stream next = 'b']! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'MU 2/28/2003 23:35'!
testReadEmptyStream
	| stream empStream |
	empStream := '' readStream.
	self
		should: [empStream size = 0].
	stream :=  SixxReadStream on: empStream.
	
	self
		should: [stream position = 0].
	self
		should: [stream atEnd].
	self
		should: [stream next isNil].
	! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 16:34'!
testReadNextContainsIdref
	| str stream firstObj secondObj thirdObj |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="OrderedCollection" >
		<sixx.object sixx.idref="0" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="5" sixx.type="Array" >
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
	</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream size = 3].
	firstObj := stream next.
	secondObj := stream next.
	thirdObj := stream next.
	self
		should: [firstObj = #(10 20 30 )].
	self
		should: [(secondObj at: 1)
				== firstObj].
	self
		should: [thirdObj = #(10 20 30 )
				and: [thirdObj ~~ firstObj]]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'MU 5/26/2003 11:36'!
testRecoveryRead
	| originalRecoveryRead   |
	[ |  str stream nextObject |
	originalRecoveryRead := SixxSetting useRecoveryRead.
	SixxSetting useRecoveryRead: true.
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object six
'.
	stream := SixxReadStream on: str readStream.
	self shouldnt: [nextObject := stream next] raise: SixxXmlParseError.
	self
		should: [nextObject class = Dictionary].
	self
		should: [(nextObject at: #key1)
				= 'value1'].
	self
		should: [(nextObject at: #key2)
				= 100].
	self
		shouldnt: [(nextObject includesKey: #key3)].
	
	] ensure: [SixxSetting useRecoveryRead: originalRecoveryRead]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:51'!
testReset
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	[stream atEnd]
		whileFalse: [stream next].
	self
		should: [stream next = nil].
	stream reset.
	self
		should: [stream position = 0]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:51'!
testSize
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream size = 3]! !

!SixxReadStreamTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:51'!
testSkip
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self
		should: [stream position = 0].
	stream skip: 1.
	self
		should: [stream position = 1].
	stream next.
	self
		should: [stream position = 2].
	stream skip: 1.
	self
		should: [stream position = 3].
	stream skip: -1.
	self
		should: [stream position = 2].
	stream skip: 2.
	self
		should: [stream position = 3]! !

SixxAbstractTestCase subclass: #SixxWriteStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testCloseTwice
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	wst close.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testKeepStreamOpening
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testNeverNextPutAndThenClose
	| st wst expected |
	expected := ''.
	st := WriteStream on: String new.
	wst := SixxWriteStream on: st.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testNextPut
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:37'!
testNextPutAll
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Character" >$a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="Character" >$b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="Character" >$c</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPutAll: 'abc'.
	wst close.
	self
		should: [st contents = expected]! !

!SixxWriteStreamTestCase methodsFor: 'tests' stamp: 'MU 9/17/2002 01:38'!
testWriteRecursiveObject
	| st wst expected arr col |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="OrderedCollection" >
		<sixx.object sixx.idref="0" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="5" sixx.type="Array" >
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
	</sixx.object>
</sixx>'.
	arr := #(10 20 30 ).
	col := OrderedCollection with: arr.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: arr.
	wst nextPut: col.
	wst nextPut: #(10 20 30 ) copy.
	wst close.
	self
		should: [st contents = expected]! !

SixxAbstractTestCase subclass: #SixxXmlParserTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxXmlParserTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 14:59'!
testParseXmlWithSixxVwXmlParserAdapter
	| sixxString result oldParser |
	self class environment
		at: #VWXMLXMLParser
		ifAbsent: [^ self].
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >100</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >abcde</sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	oldParser := SixxXmlUtil parserAdapter.
	[SixxXmlUtil parserAdapter: SixxVwXmlParserAdapter.
	result := Object readSixxFrom: sixxString.
	self
		should: [(result at: 1)
				= 100].
	self
		should: [(result at: 2)
				= 'abcde'].
	self
		should: [(result at: 3)
				= #(10 20 )].
	self
		should: [(result at: 4)
				== result]]
		ensure: [SixxXmlUtil parserAdapter: oldParser]! !

!SixxXmlParserTestCase methodsFor: 'tests' stamp: 'kuri-t 6/10/2002 15:00'!
testParseXmlWithSixxYaxoXmlParserAdapter
	| sixxString result oldParser |
	self class environment
		at: #XMLDOMParser
		ifAbsent: [^ self].
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >100</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >abcde</sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	oldParser := SixxXmlUtil parserAdapter.
	[SixxXmlUtil parserAdapter: SixxYaxoXmlParserAdapter.
	result := Object readSixxFrom: sixxString.
	self
		should: [(result at: 1)
				= 100].
	self
		should: [(result at: 2)
				= 'abcde'].
	self
		should: [(result at: 3)
				= #(10 20 )].
	self
		should: [(result at: 4)
				== result]]
		ensure: [SixxXmlUtil parserAdapter: oldParser]! !

!Dictionary methodsFor: '*sixx-printing-six' stamp: 'mu 5/10/2002 14:33'!
sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self
		associationsDo: [:each | each
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level.! !

!ShortIntegerArray class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 21:07'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^self withAll: col! !

!ShortIntegerArray methodsFor: '*sixx-printing' stamp: 'mu 6/25/2004 21:03'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

!Preferences class methodsFor: '*sixx-personalization' stamp: 'mu 6/25/2004 19:41'!
sixxLoadPreferencesFrom: aFileName
	| stream params dict desktopColor |
	stream _ SixxReadStream readOnlyFileNamed: aFileName.
	params _ stream next.
	self assert: (params isKindOf: IdentityDictionary).
	params removeKey: #PersonalDictionaryOfPreferences.
	dict _ stream next.
	self assert: (dict isKindOf: IdentityDictionary).
	desktopColor _ stream next.
	stream close.
	dict keysAndValuesDo:
		[:key :value | (self preferenceAt: key ifAbsent: [nil]) ifNotNilDo:
			[:pref | pref preferenceValue: value preferenceValue]].

	params keysAndValuesDo: [ :key :value | self setParameter: key to: value ].

	Smalltalk isMorphic
		ifTrue: [ World fillStyle: desktopColor ]
		ifFalse: [ self desktopColor: desktopColor. ScheduledControllers updateGray ].
! !

!Preferences class methodsFor: '*sixx-personalization' stamp: 'mu 6/25/2004 19:27'!
sixxStorePreferencesIn: aFileName
	| stream |
	#(Prevailing PersonalPreferences) do: [ :ea | Parameters removeKey: ea ifAbsent: []].  
	stream _ SixxWriteStream newFileNamed: aFileName.
	stream nextPut: Parameters.
	stream nextPut: DictionaryOfPreferences.
	Smalltalk isMorphic
		ifTrue: [ stream nextPut: World fillStyle ]
		ifFalse: [ stream nextPut: DesktopColor ].
	stream close.! !

!Point class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 20:31'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| readStr x y |
	readStr := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	x _ (readStr upTo: $@) asNumber.
	y _ (readStr upToEnd) asNumber.
	^self x: x y: y! !

!Point methodsFor: '*sixx-printing' stamp: 'mu 6/25/2004 20:23'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: x printString.
	aStream nextPut: $@.
	aStream nextPutAll: y printString.
	
	! !

!Boolean class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 19:27'!
createInstanceOf: aClass withSixxElement: sixxElement
	"More 'safer' implementation"
	| cData |
	cData := SixxXmlUtil characterDataFrom: sixxElement.
	^cData = 'true'
	! !

!Boolean methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 16:20'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !

!RunArray class methodsFor: '*sixx-instance creation' stamp: 'MU 7/21/2002 23:30'!
createInstanceOf: aClass withSixxElement: sixxElement
	"squeak specific"
	
	^aClass basicNew! !

!RunArray methodsFor: '*sixx-initializing' stamp: 'MU 7/21/2002 23:35'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]! !

!RunArray methodsFor: '*sixx-printing' stamp: 'MU 7/9/2002 01:25'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream cr.
	self runs
		sixxOn: aStream
		name: 'runs'
		indent: level + 1
		context: dictionary.
	self values
		sixxOn: aStream
		name: 'values'
		indent: level + 1
		context: dictionary.
	aStream tab: level! !

!Symbol class methodsFor: '*sixx-instance creation' stamp: 'mu 5/9/2002 17:46'!
createInstanceOf: aClass withSixxElement: sixxElement
	^(super createInstanceOf: aClass withSixxElement: sixxElement) asSymbol! !

!Symbol methodsFor: '*sixx-private' stamp: 'mu 2/7/2006 21:12'!
sixxType
	^#Symbol! !

!Number class methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/15/2002 18:06'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ (SixxXmlUtil characterDataFrom: sixxElement) asNumber
	! !

!Number methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:36'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self asString
	! !

!ClassDescription methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:32'!
sixxContentOn: aStream indent: level context: dictionary
	| instVars startIndex  |	
	aStream cr.
	instVars := self class allInstVarNames.
	startIndex := Object class allInstVarNames size + 1.
	startIndex to: instVars size do: [:idx | 
			(self instVarAt: idx)
				sixxOn: aStream
				name: (instVars at: idx)
				indent: level + 1
				context: dictionary].! !

!TTCFont class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 23:38'!
familyName: aName size: aSize emphasized: emphasisCode
	^self familyName: aName pointSize: aSize emphasis: emphasisCode! !

!Interval class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:22'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Interval methodsFor: '*sixx-printing' stamp: 'minami 3/18/2003 01:47'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self printString! !

!FloatArray class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:19'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^ col asFloatArray! !

!FloatArray methodsFor: '*sixx-printing' stamp: 'MU 6/29/2002 16:03'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

Warning subclass: #SixxWarning
	instanceVariableNames: 'className element context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

SixxWarning subclass: #SixxClassNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxClassNotFound methodsFor: 'exceptionDescription' stamp: 'MU 10/27/2002 19:39'!
description
	"Return a textual description of the exception."
	self className isNil ifTrue: [ ^super description , ': ', 'Type cannot be detected from XML'].
	^ super description , ': ' , self className! !

SixxWarning subclass: #SixxInvalidDeserialization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxInvalidDeserialization methodsFor: 'exceptionDescription' stamp: 'MU 10/27/2002 19:50'!
description
	"Return a textual description of the exception."
	^ super description , ': ' , self className printString! !

SixxWarning subclass: #SixxInvalidSerialization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxInvalidSerialization methodsFor: 'exceptionDescription' stamp: 'MU 10/27/2002 19:50'!
description
	"Return a textual description of the exception."
	^ super description , ': ' , self className printString! !

SixxWarning subclass: #SixxNewFailed
	instanceVariableNames: 'alternativeInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxWarning class methodsFor: 'instance creation' stamp: 'MU 10/27/2002 17:23'!
signal: className
	^self signal: className context: nil ! !

!SixxWarning class methodsFor: 'instance creation' stamp: 'MU 10/27/2002 17:23'!
signal: className context: dictionary 
	^self signal: className element: nil context: dictionary ! !

!SixxWarning class methodsFor: 'instance creation' stamp: 'MU 10/27/2002 17:27'!
signal: className element: xmlElement 
	^self signal: className element: xmlElement context: nil ! !

!SixxWarning class methodsFor: 'instance creation' stamp: 'MU 10/26/2002 01:35'!
signal: className element: xmlElement context: dictionary 
	| inst |
	inst := self new.
	inst className: className.
	inst element: xmlElement.
	inst context: dictionary.
	^ inst signal! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
className

	^className! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
className: aValue

	className := aValue! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
context

	^context! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
context: aValue

	context := aValue! !

!SixxWarning methodsFor: 'exceptionDescription' stamp: 'MU 10/26/2002 01:35'!
defaultAction
	Transcript cr; show: '#warning# ' , self description.
	self resume! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
element
	^ element! !

!SixxWarning methodsFor: 'accessing' stamp: 'MU 10/26/2002 01:35'!
element: aValue 
	element := aValue! !

!String class methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/15/2002 18:07'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ SixxXmlUtil characterDataFrom: sixxElement! !

!String methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 20:04'!
sixxContentOn: aStream indent: level context: dictionary
	SixxXmlUtil writeXmlText: self on: aStream! !

!String methodsFor: '*sixx-private' stamp: 'mu 2/7/2006 21:11'!
sixxType
	^#String! !

!AbstractFont class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 23:35'!
createInstanceOf: aClass withSixxElement: sixxElement 

	"For old format"
	| stream space familyName size emphasisCode |
	(SixxXmlUtil elementsFrom: sixxElement ) isEmpty ifFalse: [
		^super createInstanceOf: aClass withSixxElement: sixxElement
	].

	stream := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	space := Character space.
	familyName := stream upTo: space.
	size := (stream upTo: space) asInteger.
	emphasisCode := (stream upTo: space) asInteger.
	^self familyName: familyName size: size emphasized: emphasisCode.
! !

!AbstractFont methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 23:34'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!AbstractFont methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 23:33'!
sixxContentString
	"Squeak Specific"
	^self fontNameWithPointSize, ' ', self emphasis asString! !

!ContextPart class methodsFor: '*sixx-instance creation' stamp: 'MU 10/27/2002 17:35'!
createInstanceOf: aClass withSixxElement: sixxElement 
	SixxInvalidDeserialization signal: aClass name element: sixxElement. 
	^nil! !

!ContextPart methodsFor: '*sixx-printing' stamp: 'MU 10/27/2002 17:24'!
sixxContentOn: aStream indent: level context: dictionary
	SixxInvalidSerialization signal: self class name context: dictionary.
	aStream nextPutAll: self printString! !

!Behavior methodsFor: '*sixx-private' stamp: 'MU 3/6/2003 12:57'!
classFromSixxElement: sixxElement context: dictionary 
	| isClassClass type className retClass |
	isClassClass := false.
	type := self typeFromSixxElement: sixxElement.
	type isNil
		ifTrue: [^ nil].
	className := (type includes: Character space)
				ifTrue: [isClassClass := true.
					type copyUpTo: Character space]
				ifFalse: [type].
	retClass := SixxPortableUtil
				classAt: className
				in: (self envFromSixxElement: sixxElement).
	isClassClass
		ifTrue: [retClass := retClass class].
	^ retClass isNil
		ifTrue: [SixxClassNotFound
				signal: className
				element: sixxElement
				context: dictionary]
		ifFalse: [retClass]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 03:25'!
createInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"
	^ aClass isVariable
		ifTrue: [self createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement]
		ifFalse: [self sixxNew: aClass withSixxElement: sixxElement]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 03:25'!
createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"
	| nonameElems size |
	nonameElems := (SixxXmlUtil elementsFrom: sixxElement)
				select: [:each | (self nameFromSixxElement: each) isNil].
	size := nonameElems isEmpty
				ifTrue: [0]
				ifFalse: [nonameElems size].
	^ self
		sixxNew: aClass
		size: size
		withSixxElement: sixxElement! !

!Behavior methodsFor: '*sixx-private' stamp: 'MU 3/6/2003 12:57'!
envFromSixxElement: sixxElement 
	| environmentQualifier |
	(SixxXmlUtil isTextFrom: sixxElement)
		ifTrue: [^ nil].
	environmentQualifier := SixxXmlUtil attributeAt: #'sixx.env' from: sixxElement.
	^ environmentQualifier isNil
		ifFalse: [environmentQualifier asSymbol]! !

!Behavior methodsFor: '*sixx-private' stamp: 'MU 5/31/2002 15:21'!
fromSixxElement: sixxElement context: aDictionary 
	^ (self includesRefInstanceFromSixxElement: sixxElement context: aDictionary)
		ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]
		ifFalse: [self newInstanceFromSixxElement: sixxElement context: aDictionary]! !

!Behavior methodsFor: '*sixx-private' stamp: 'kuri-t 5/15/2002 18:10'!
idFromSixxElement: sixxElement 
	| id |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	id := SixxXmlUtil attributeAt: #'sixx.id' from: sixxElement .
	^ id isNil
		ifFalse: [id asSymbol]! !

!Behavior methodsFor: '*sixx-private' stamp: 'kuri-t 5/15/2002 18:10'!
idrefFromSixxElement: sixxElement
	| idref |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	idref := SixxXmlUtil attributeAt: #'sixx.idref' from: sixxElement .
	^ idref isNil
		ifFalse: [idref asSymbol]! !

!Behavior methodsFor: '*sixx-private' stamp: 'kuri-t 6/3/2002 16:06'!
includesRefInstanceFromSixxElement: sixxElement context: aDictionary 
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^ idref isNil
		ifTrue: [false]
		ifFalse: [aDictionary includesKey: idref]! !

!Behavior methodsFor: '*sixx-private' stamp: 'kuri-t 5/15/2002 18:10'!
nameFromSixxElement: sixxElement 
	| nm |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	nm := SixxXmlUtil attributeAt: #'sixx.name' from: sixxElement .
	^ nm isNil
		ifFalse: [nm asSymbol]! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 6/24/2004 22:23'!
newInstanceFromSixxElement: sixxElement context: aDictionary 
	| class inst |
	class := self classFromSixxElement: sixxElement context: aDictionary .
	class isNil
		ifTrue: [class := SixxClassNotFound
				signal: (self typeFromSixxElement: sixxElement)
				element: sixxElement
				context: aDictionary].
	inst := class createInstanceOf: class withSixxElement: sixxElement.
	aDictionary
		at: (self idFromSixxElement: sixxElement)
		put: inst.
	inst initializeFromSixxElement: sixxElement context: aDictionary.
	inst sixxInitialize.
	^ inst! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'kuri-t 6/3/2002 16:29'!
readSixxFromSixxElement: sixxElement context: aDictionary 
	| rootClass typeAttr |
	typeAttr := self typeFromSixxElement: sixxElement.
	^typeAttr isNil
		ifTrue: [(self includesRefInstanceFromSixxElement: sixxElement context: aDictionary)
				ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]]
		ifFalse: [rootClass := self classFromSixxElement: sixxElement context: aDictionary.
			rootClass isNil
				ifFalse: [rootClass fromSixxElement: sixxElement context: aDictionary]]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/20/2002 14:05'!
readSixxFrom: xmlStringOrStream 
	^ self readSixxFrom: xmlStringOrStream context: IdentityDictionary new! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/20/2002 14:04'!
readSixxFrom: xmlStringOrStream context: aDictionary 
	| topElem |
	topElem := SixxXmlUtil parseXml: xmlStringOrStream.
	^ self readSixxFromSixxElement: topElem context: aDictionary! !

!Behavior methodsFor: '*sixx-private' stamp: 'kuri-t 5/14/2002 19:43'!
refInstanceFromSixxElement: sixxElement context: aDictionary 
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^aDictionary at: idref! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/26/2004 16:21'!
sixxNew: aClass size: size withSixxElement: sixxElement 
	^ [aClass new: size]
		on: Error
		do: [:ex | 
			| alterClass | 
			alterClass := SixxNewFailed signal: aClass name element: sixxElement.
			alterClass isNil
				ifTrue: [[aClass basicNew: size] on: Error do: [self sixxNew: aClass withSixxElement: sixxElement ]]
				ifFalse: [alterClass basicNew: size]]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/24/2004 22:20'!
sixxNew: aClass withSixxElement: sixxElement 
	^[aClass new]
		on: Error
		do: [:ex | 
			| alterClass | 
			alterClass := SixxNewFailed signal: aClass name element: sixxElement.
			alterClass isNil
				ifTrue: [aClass basicNew]
				ifFalse: [alterClass basicNew]]! !

!Behavior methodsFor: '*sixx-private' stamp: 'kuri-t 5/15/2002 18:10'!
typeFromSixxElement: sixxElement 
	| type |
	(SixxXmlUtil isTextFrom: sixxElement)
		ifTrue: [^ nil].
	type := SixxXmlUtil attributeAt: #'sixx.type' from: sixxElement.
	^ type isNil
		ifFalse: [type asSymbol]! !

!FixedFaceFont methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 23:33'!
emphasis
	^0! !

Error subclass: #SixxXmlParseError
	instanceVariableNames: 'originalError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Core'!

!SixxXmlParseError class methodsFor: 'instance creation' stamp: 'MU 5/24/2003 19:00'!
originalError: anError
	^self new originalError: anError! !

!SixxXmlParseError methodsFor: 'accessing' stamp: 'MU 5/24/2003 18:59'!
originalError
	^originalError! !

!SixxXmlParseError methodsFor: 'accessing' stamp: 'MU 5/24/2003 18:59'!
originalError: anError
	originalError := anError! !

!UndefinedObject class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:20'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!UndefinedObject methodsFor: '*sixx-private' stamp: 'MU 9/16/2002 18:55'!
asSixxKey
	"For some Smalltalks which do not support nil element in IdentityDictionary"
	^#'SIXX-UndefinedObject(98ea8c30-2bf8-4d23-9da2-ad1ee0e29eff)'
! !

!UndefinedObject methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:36'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !

!UndefinedObject methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 18:56'!
sixxOn: aStream name: nameString indent: level context: dictionary 
	| key |
	key := self asSixxKey.
	aStream tab: level.
	(dictionary includesKey: key )
		ifTrue: [aStream
				nextPutAll: (self
						sixxRefTagStartString: (dictionary at: key) name: nameString)]
		ifFalse: [| idStr | 
			idStr := dictionary size asString.			
			dictionary at: key put: idStr.
			aStream
				nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !

!DateAndTime class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 19:21'!
createInstanceOf: aClass withSixxElement: sixxElement 

	"For old format"
	(SixxXmlUtil elementsFrom: sixxElement ) isEmpty ifFalse: [
		^super createInstanceOf: aClass withSixxElement: sixxElement
	].

	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!DateAndTime methodsFor: '*sixx-printing' stamp: 'mu 7/20/2006 15:47'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!DateAndTime methodsFor: '*sixx-private' stamp: 'mu 7/20/2006 15:47'!
sixxContentString
	"Squeak Specific"
	^self printString! !

!WordArray class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:21'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^ col asWordArray! !

!WordArray methodsFor: '*sixx-printing' stamp: 'MU 6/29/2002 16:00'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

!ShortPointArray class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 21:28'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| rawCol points index pointStream |
	rawCol := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	rawCol := rawCol reject: [:e | e == #@].
	points := (Array new: rawCol size //2).
	index := 1.
	pointStream _  rawCol readStream.
	[pointStream atEnd] whileFalse: [
		points at: index put: (Point x: pointStream next asNumber y: pointStream next asNumber).
		index := index + 1.
	].
	
	^self withAll: points! !

!TTCFontSet class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 23:38'!
familyName: aName size: aSize emphasized: emphasisCode
	^self familyName: aName pointSize: aSize emphasis: emphasisCode! !

!ArrayedCollection methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 03:44'!
initializeFromSixxElement: sixxElement context: aDictionary 
	"override to use #initializeMixedFieldsFromSixxElement:context: if having some inst vars"
	| idx |
	idx := 1.
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | childInst | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [childInst := self class fromSixxElement: elem context: aDictionary.
					self at: idx put: childInst.
					idx := idx + 1]]! !

!Rectangle class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 19:38'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| readStr origin corner |

	"For old format"
	(SixxXmlUtil elementsFrom: sixxElement ) isEmpty ifFalse: [
		^super createInstanceOf: aClass withSixxElement: sixxElement
	].

	readStr := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	origin := ((readStr upTo: $@) asNumber) @ (readStr upTo: Character space) asNumber.
	readStr upToAll: 'corner: '.
	corner := ((readStr upTo: $@) asNumber) @ (readStr upToEnd) asNumber.
	^origin corner: corner
! !

!Rectangle methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 19:31'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self printString.
	! !

!Text methodsFor: '*sixx-initializing' stamp: 'MU 7/21/2002 23:35'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst ]]]! !

!Text methodsFor: '*sixx-printing' stamp: 'MU 7/9/2002 01:11'!
sixxContentOn: aStream indent: level context: dictionary
	self sixxChildrenContentsOn: aStream indent: level + 1 context: dictionary.
	aStream tab: level.! !

!Character class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:17'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Character methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:37'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString
	! !

!Collection class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 03:32'!
createInstanceOf: aClass withSixxElement: sixxElement 
	"override to use #createMixedFieldsInstanceOf:withSixxElement: if you have extra inst vars"
	^ self
		sixxNew: aClass
		size: (SixxXmlUtil elementsFrom: sixxElement) size
		withSixxElement: sixxElement! !

!Collection methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 03:59'!
initializeFromSixxElement: sixxElement context: aDictionary 
	"override to use #initializeMixedFieldsFromSixxElement:context: if having some inst vars"
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | 
			| childInst | 
			childInst := self class fromSixxElement: elem context: aDictionary.
			self add: childInst]! !

!Collection methodsFor: '*sixx-printing' stamp: 'mu 6/25/2004 00:37'!
sixxContentOn: aStream indent: level context: dictionary
	"default just uses #do: - override it to use #sixxAllFieldsOn:indent:context: if your collection need to store some inst vars"
	aStream cr.
	self
		do: [:each | each
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level.! !

!Collection methodsFor: '*sixx-private' stamp: 'mu 6/25/2004 04:55'!
sixxIndexFieldsOn: aStream indent: level context: dictionary
	self size = 0 ifTrue: [^self].
	aStream cr.
	self do: 
			[:each | 
			each 
				sixxOn: aStream
				indent: level
				context: dictionary]

! !

!Collection methodsFor: '*sixx-private' stamp: 'mu 6/25/2004 04:55'!
sixxMixedFieldsOn: aStream indent: level context: dictionary
	"override"
	"Usually Collection's inst vars are not needed for serialization"
	self sixxIndexFieldsOn: aStream indent: level context: dictionary.! !

!Metaclass methodsFor: '*sixx-instance creation' stamp: 'MU 9/2/2002 02:46'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ aClass isMeta
		ifTrue: [aClass soleInstance]
		ifFalse: [aClass]! !

!Integer class methodsFor: '*sixx-instance creation' stamp: 'mu 6/26/2004 10:25'!
readShortHexFrom: aStream 
	| digit value startPos |
	value := 0.
	startPos := aStream position.
	[aStream atEnd]
		whileFalse: 
			[digit := aStream next digitValue.
			(digit < 0 or: [digit >= 16])
				ifTrue: 
					[aStream skip: -1.
					aStream position = startPos ifTrue: [self error: 'At least one digit expected here'].
					^ value]
				ifFalse: [value := value * 16 + digit]].
	^ value! !

!Integer methodsFor: '*sixx-printing' stamp: 'mu 6/26/2004 12:11'!
shortHexString
	| current letters digits quo i |
	digits := '0123456789ABCDEF'.
	current := self.
	i := self digitLength * 8.
	letters := String new: i.
	[current < 16] whileFalse: 
		[quo := current quo: 16.
		letters at: i put: (digits at: (current - (quo * 16)) + 1).
		i := i - 1.
		current := quo].
	letters at: i put: (digits at: current + 1).
	^letters copyFrom: i to: letters size! !

Array variableSubclass: #SixxMockVariableNewFailedClass
	instanceVariableNames: 'att1 att2 att3Block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

SixxMockVariableNewFailedClass variableSubclass: #SixxMockVariableAlternativeClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Test'!

!SixxMockVariableAlternativeClass class methodsFor: 'instance creation' stamp: 'mu 6/24/2004 23:06'!
new: size
	"new: is OK for me"
	^self basicNew: size! !

!SixxMockVariableNewFailedClass class methodsFor: 'instance creation-sixx' stamp: 'mu 6/25/2004 03:32'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^self createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement ! !

!SixxMockVariableNewFailedClass class methodsFor: 'instance creation' stamp: 'mu 6/24/2004 23:12'!
new: size
	Error new signal: '#new: should not be called'! !

!SixxMockVariableNewFailedClass class methodsFor: 'for tests' stamp: 'mu 6/25/2004 00:05'!
prototype1
	"self prototype1"
	| inst |
	inst := self basicNew: 3.
	1 to: 3 do: [:idx | inst at: idx put: idx printString].
	inst att1: 1.
	inst att2: 'TWO'.
	inst att3Block: [:this | 'is block'].
	^inst! !

!SixxMockVariableNewFailedClass class methodsFor: 'for tests' stamp: 'mu 6/25/2004 00:06'!
prototype2
	"self prototype2"
	| inst |
	inst := self basicNew: 3.
	1 to: 3 do: [:idx | inst at: idx put: idx printString].
	inst att1: 3.
	inst att2: 'Four'.
	inst att3Block: [:this :is | 'block2'].
	^inst! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:04'!
att1
	^att1! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:04'!
att1: aValue
	att1 := aValue! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:05'!
att2
	^att2! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:05'!
att2: aValue
	att2 := aValue! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:05'!
att3Block
	^att3Block! !

!SixxMockVariableNewFailedClass methodsFor: 'accessing' stamp: 'mu 6/25/2004 00:05'!
att3Block: aValue
	att3Block := aValue! !

!SixxMockVariableNewFailedClass methodsFor: 'initializing-sixx' stamp: 'mu 6/25/2004 03:45'!
initializeFromSixxElement: sixxElement context: aDictionary 
	self initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary! !

!SixxMockVariableNewFailedClass methodsFor: 'private-sixx' stamp: 'mu 6/26/2004 16:45'!
sixxContentOn: aStream indent: level context: dictionary
	"override if you like"
	self sixxInstVarsOn: aStream indent: level context: dictionary.
	self sixxIndexFieldsOn: aStream indent: level context: dictionary.! !

!SixxMockVariableNewFailedClass methodsFor: 'initializing-sixx' stamp: 'mu 6/25/2004 00:04'!
sixxInitialize
	att3Block := [:a :b | a < b].! !
SixxConstants initialize!
SixxCustomStoreLoadExample initialize!
SixxMockClassForUnitTest initialize!
SixxMockSuperClassForUnitTest initialize!
SixxPortableUtil initialize!
SixxXmlUtil initialize!
